/*****************************************************
 название плагина не менять! при выставлении координат
 таймера требуется автоматическая перезагрузка
******************************************************/


#pragma semicolon 1
#include <sdktools>
#include <sourcemod>
#include <cstrike>

#define VERSION "5.0"

new Handle:db = INVALID_HANDLE;
new Handle:cvarEnable = INVALID_HANDLE;
new Handle:cvarTimer = INVALID_HANDLE;
new Handle:cvarRestore = INVALID_HANDLE;
new Handle:cvarCpLimit = INVALID_HANDLE;
new Handle:cvarNoblock = INVALID_HANDLE;
new Handle:cvarTimerHudHint = INVALID_HANDLE;
new Handle:cvarNoFlash = INVALID_HANDLE;
new Handle:cvarAir = INVALID_HANDLE;
new Handle:cvarScoutLimit = INVALID_HANDLE;
new Handle:cvarGravity = INVALID_HANDLE;
new Handle:cvarHealClient = INVALID_HANDLE;
new Handle:handler_X_Red[MAXPLAYERS+1] = {INVALID_HANDLE,...};
new Handle:handler_X_Blue[MAXPLAYERS+1] = {INVALID_HANDLE,...};
new Handle:XO_ForMaps_hand[MAXPLAYERS+1] = {INVALID_HANDLE,...};
new Handle:TimerTimer[MAXPLAYERS+1];
new Handle:ConfigurationFile;
new Handle:ConfigurationFilePath;
new bool:g_NullCoords;
new bool:g_Enable = false;
new bool:g_Timer = false;
new bool:g_Restore = false;
new bool:g_Noblock = false;
new bool:g_TimerHudHint = false;
new bool:g_NoFlash = false;
new bool:g_Gravity = false;
new bool:g_HealClient = false;
new bool:X_setPos[MAXPLAYERS+1][2];
new bool:X_setPos_ForMap[MAXPLAYERS+1][2];
new bool:blocking[MAXPLAYERS+1];
new bool:OnTimer[MAXPLAYERS+1];
new bool:UserTimerActive[MAXPLAYERS+1];
new bool:UserTimerHudOrHint[MAXPLAYERS+1];
new bool:UserTimerSpeed[MAXPLAYERS+1];
new bool:g_ClientInGravity[MAXPLAYERS+1];
new bool:NoClipOnOff;
new Float:PoSiTiOnS_Red[MAXPLAYERS+1][3];
new Float:PoSiTiOnS_Blue[MAXPLAYERS+1][3];
new Float:PoSiTiOnSMap_Red[MAXPLAYERS+1][3];
new Float:PoSiTiOnSMap_Blue[MAXPLAYERS+1][3];
new Float:playercords[MAXPLAYERS+1][101][3];
new Float:playerangles[MAXPLAYERS+1][101][3];
new Float:g_MapBeginCoords[3];
new Float:g_MapEndCoords[3];
new String:GetPath[256];
new String:GetFileName[256];
new String:map[64];
new g_Rank;
new g_Total;
new String:g_SelectedName[255];
new UserAddedIndb[MAXPLAYERS+1];
new currentcp[MAXPLAYERS+1];
new wholecp[MAXPLAYERS+1];
new scouts[MAXPLAYERS+1];
new g_ClientTime[MAXPLAYERS+1] = 0;
new g_ClientJumps[MAXPLAYERS+1] = 0;
new g_ClientSpeedkmh[MAXPLAYERS+1] = 0;
new g_ClientSpeedunts[MAXPLAYERS+1] = 0;
new g_UserMapFinisCount[MAXPLAYERS+1] = 0;
//new sec = 5;
new Plasmabeam;

new String:sql_CreateCp[] = "CREATE TABLE IF NOT EXISTS checkpoints (map varchar(255) NOT NULL default '',steamid varchar(255) NOT NULL default '',cords varchar(255) NOT NULL default '',angles varchar(255) NOT NULL default '',last_connect timestamp NOT NULL default CURRENT_TIMESTAMP)";
new String:sql_CreateTimer[]  = "CREATE TABLE IF NOT EXISTS timer (map varchar(255) NOT NULL default 'mapname', begincords varchar(255) NOT NULL default '0.000000:0.000000:0.000000', endcords varchar(255) NOT NULL default '0.000000:0.000000:0.000000')";
new String:sql_CreateStats[] = "CREATE TABLE IF NOT EXISTS usersstats (name varchar(255) NOT NULL default 'username', steamid varchar(255) NOT NULL default 'user_steamid', time int(12) NOT NULL default '-1', jumps int(12) NOT NULL default '-1', speedkmh int(12) NOT NULL default '-1', speedunts int(12) NOT NULL default '-1', map varchar(255) NOT NULL default 'mapname', map_fc int(12) NOT NULL default '-1')";

public Plugin:myinfo =
{
	name = "Bunnyhop Mod",
	author = "t*Q (102 RUS)",
	description = "Bunnyhop Mod (RUSSIA)",
	version = VERSION,
	url = "www.hlmod.ru"
}

public OnPluginStart()
{
	LoadTranslations("BunnyhopMod.phrases");
	GetCurrentMap(map, 64);


	decl String:error[256];
	db = SQL_Connect("BunnyhopMod", false, error, sizeof(error));	

	if(db == INVALID_HANDLE)
	{
		LogError("[Bunnyhop] Failed to connect to database (%s)", error);
		return;
	}

	SQL_LockDatabase(db);
	
	if(SQL_FastQuery(db, sql_CreateCp) == false)
	{
		LogError("[Bunnyhop] Could not create table checkpoints");
		PrintToServer("%s", sql_CreateCp);
		return;
	}
	if(SQL_FastQuery(db, sql_CreateTimer) == false)
	{
		LogError("[Bunnyhop] Could not create table timer");
		PrintToServer("%s", sql_CreateTimer);
		return;
	}
	if(SQL_FastQuery(db, sql_CreateStats) == false)
	{
		LogError("[Bunnyhop] Could not create table usersstats");
		PrintToServer("%s", sql_CreateStats);
		return;
	}

	PrintToServer("[Bunnyhop] Successful connected to database...");
	SQL_UnlockDatabase(db);

	decl String:query[255];
	Format(query, sizeof(query), "SELECT begincords, endcords FROM timer WHERE map = '%s'", map);
	SQL_TQuery(db, SQL_SelectTimerCallback, query);

	RegConsoleCmd("say", Command_Say);
	HookEvent("player_spawn", Event_player_spawn);
	HookEvent("player_footstep",Event_player_footstep);
	HookEvent("player_jump",Event_player_jump);


	ConfigurationFile = CreateConVar("bh_ConfigurationFile", "BunnyhopMod.cfg", "File");
	ConfigurationFilePath = CreateConVar("bh_ConfigurationFilepath", "cfg/sourcemod/", "File Path");
	GetConVarString(ConfigurationFile, GetFileName, sizeof(GetFileName));
	GetConVarString(ConfigurationFilePath, GetPath, sizeof(GetPath));
	
	CreateConVar("bh_version", VERSION, "Bunnyhop t*Q mod version.", FCVAR_DONTRECORD|FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	
	cvarEnable = CreateConVar("bh_enabled", "1", "Enable/Disable the plugin.", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	g_Enable = GetConVarBool(cvarEnable);
	HookConVarChange(cvarEnable, OnSettingChanged);
	
	cvarTimer = CreateConVar("bh_timer_enable", "1", "Enable/Disable map based timer|Разрешить/Запретить таймер на картах\n1 - Enable\n0 - Disable", FCVAR_PLUGIN);
	g_Timer = GetConVarBool(cvarTimer);
	HookConVarChange(cvarTimer, OnSettingChanged);
	
	cvarRestore = CreateConVar("bh_restore", "1", "Enable/Disable automatic saving of checkpoints to database|Разрешить/Запретить восстановление чекпоинтов из базы данных\n1 - Enable\n0 - Disable", FCVAR_PLUGIN);
	g_Restore = GetConVarBool(cvarRestore);
	HookConVarChange(cvarRestore, OnSettingChanged);
	
	cvarCpLimit = CreateConVar("bh_cplimit", "20", "Sets the cp limit for each player|Максимальное количество чекпоинтов\n5 - min\n50 - max", FCVAR_PLUGIN);
	HookConVarChange(cvarCpLimit, OnSettingChanged);
	
	cvarNoblock = CreateConVar("bh_noblock", "1", "Enable/Disable player blocking|Разрешить/Запретить команду !block\n1 - Enable\n0 - Disable", FCVAR_PLUGIN);
	g_Noblock = GetConVarBool(cvarNoblock);
	HookConVarChange(cvarNoblock, OnSettingChanged);
	
	cvarTimerHudHint = CreateConVar("bh_timerhudhint", "1", "Timer show HudHint or HintText|Таймер в виде HudHint или HintText\n1 - Hudhint\n0 - HintText", FCVAR_PLUGIN);
	g_TimerHudHint = GetConVarBool(cvarTimerHudHint);
	HookConVarChange(cvarTimerHudHint, OnSettingChanged);
	
	cvarNoFlash  = CreateConVar("bh_noflash", "1", "Enable/Disable flashbang blind|Вкл/Выкл ослепление от флэшки\n1 - Enable\n0 - Disable", FCVAR_PLUGIN);
	g_NoFlash = GetConVarBool(cvarNoFlash);
	HookConVarChange(cvarNoFlash, OnSettingChanged);
	if(cvarNoFlash)
	{
		HookEvent("player_blind" , Event_flashbang_detonate);
	}

	cvarScoutLimit = CreateConVar("bh_scoutlimit", "3", "Sets the scout limit for each player|Максимальное количество скаутов\n10 - max\n0 - Disabled" , FCVAR_PLUGIN);
	HookConVarChange(cvarScoutLimit, OnSettingChanged);
	
	cvarGravity = CreateConVar("bh_gravity", "0", "Enable/Disable player gravity|Разрешить/Запретить комманды !lowgrav/!normalgrav\n1 - Enable\n0 - Disable", FCVAR_PLUGIN);
	g_Gravity = GetConVarBool(cvarGravity);
	HookConVarChange(cvarGravity, OnSettingChanged);
	
	cvarHealClient = CreateConVar("bh_healclient", "1", "Enable/Disable healing of damage|Разрешить/Запретить восстановление ХП\n1 - Enable\n0 - Disable", FCVAR_PLUGIN);
	g_HealClient = GetConVarBool(cvarHealClient);
	HookConVarChange(cvarHealClient, OnSettingChanged);
	if(cvarHealClient)
		HookEvent("player_hurt", Event_player_hurt);
	
	cvarAir = FindConVar("sv_airaccelerate");
	
	RegAdminCmd("bh_timer", AdminDisableEnableTimer, ADMFLAG_CONFIG, "on/off timer|Быстро Включить/отключить таймер");
	RegAdminCmd("bh_resetcp", Admin_ResetCp, ADMFLAG_CONFIG, "Resets checkpoints of all players|Стереть всю базу данных чекпоинтов");
	RegAdminCmd("bh_purgecp", Admin_PurgeCp, ADMFLAG_CONFIG, "Purges checkpoints of all players|Стереть из базы чекпоинтов, данные игроков которых небыло на сервере <...> дней");
	RegAdminCmd("bh_resettimer", Admin_ResetTimer, ADMFLAG_CONFIG, "Resets timers of all players|Стереть все координыты таймера");
	RegAdminCmd("bh_resetstats", Admin_ResetStats, ADMFLAG_CONFIG, "Resets stats of all players|Стереть всю статистику и рекорды НА ВСЕХ КАРТАХ из базы данных");
	RegAdminCmd("bh_admin", CpAdmin, ADMFLAG_CONFIG, "Admin menu|Меню администратора");

	for(new i = 0; i <= MAXPLAYERS; i++)
	{
			
		if(UserTimerActive[i] == false)
		{
			UserTimerActive[i] = true;
		}
		if(g_TimerHudHint == false || g_TimerHudHint == true)
		{
			UserTimerHudOrHint[i] = true;
		}
	}


	PrintToServer("[Bunnyhop] Successful loaded...");
}

public OnConfigsExecuted()
{
	new String:PathBuilded[256];
	Format(PathBuilded, sizeof(PathBuilded), "%s%s", GetPath, GetFileName);
	new Handle:readCFG = OpenFile(PathBuilded, "rt");
	if (readCFG == INVALID_HANDLE)
	{
		PrintToServer("[Bunnyhop Mod] config file autocreated in : %s", PathBuilded);
		CfgWrite();
	}
	else
	{
		CfgRead();
	}
}

public OnMapStart()
{
	Plasmabeam = PrecacheModel("materials/sprites/plasmabeam.vmt");

	PrecacheSound("player/suit_sprint.wav", true);
	PrecacheSound("ambient/3dmeagle.wav", true);
	PrecacheSound("buttons/button9.wav", true);
	PrecacheSound("buttons/button2.wav", true);
	PrecacheSound("buttons/button19.wav", true);
	PrecacheSound("buttons/button17.wav", true);
 
	GetCurrentMap(map, 64);
	decl String:query[255];
	Format(query, sizeof(query), "SELECT begincords, endcords FROM timer WHERE map = '%s'", map);
	SQL_TQuery(db, SQL_SelectTimerCallback, query);

	if(g_Enable)
	{
		for(new i = 0; i <= MAXPLAYERS; i++)
		{
			if (TimerTimer[i] != INVALID_HANDLE)
			{
				CloseHandle(TimerTimer[i]);
				CloseHandle(handler_X_Blue[i]);
				CloseHandle(handler_X_Red[i]);
				TimerTimer[i] = INVALID_HANDLE;
				handler_X_Blue[i] = INVALID_HANDLE;
				handler_X_Red[i] = INVALID_HANDLE;
			}

			currentcp[i] = 0;
			wholecp[i] = 0;
			scouts[i] = 0;
			g_ClientTime[i] = 0;
			g_ClientJumps[i] = 0;
			g_ClientSpeedkmh[i] = 0;
			g_ClientSpeedunts[i] = 0;
			g_UserMapFinisCount[i] = 0;
			
			if(UserTimerActive[i] == false)
			{
				UserTimerActive[i] = true;
			}

		}
	}
}

public SQL_SelectTimerCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if(hndl == INVALID_HANDLE)
		LogError("[Bunnyhop] Error loading checkpoint (%s)", error);
	
	if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl))
	{
		new String:bcords[255];
		new String:ecords[255];
		SQL_FetchString(hndl, 0, bcords, sizeof(bcords));
		SQL_FetchString(hndl, 1, ecords, sizeof(ecords));

		if(StrEqual(bcords, "0.000000:0.000000:0.000000") && StrEqual(ecords, "0.000000:0.000000:0.000000"))
		{
			g_NullCoords = true;
			CreateTimer(2.0, T_X_SetEraser);
			CreateTimer(2.0, T_Erase_OX_InMap);
		}
		else
		{
			new String:cbuff[3][255];
			ExplodeString(bcords, ":", cbuff, 3, 255);
			g_MapBeginCoords[0] = StringToFloat(cbuff[0]);
			g_MapBeginCoords[1] = StringToFloat(cbuff[1]);
			g_MapBeginCoords[2] = StringToFloat(cbuff[2]);
			ExplodeString(ecords, ":", cbuff, 3, 255);
			g_MapEndCoords[0] = StringToFloat(cbuff[0]);
			g_MapEndCoords[1] = StringToFloat(cbuff[1]);
			g_MapEndCoords[2] = StringToFloat(cbuff[2]);
			g_NullCoords = false;
			CreateTimer(2.0, T_X_SetEraser);
			CreateTimer(2.0, T_Set_OX_InMap);
		}
	}
	else
	{
		decl String:query[255];
		Format(query, sizeof(query), "INSERT INTO timer (map) VALUES ('%s')", map);		
		SQL_TQuery(db, SQL_CheckCallback, query);

		g_NullCoords = true;
		CreateTimer(2.0, T_X_SetEraser);
		CreateTimer(2.0, T_Erase_OX_InMap);
	}
}

public SQL_SelectCpCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	new client = data;
	if(hndl == INVALID_HANDLE)
		LogError("[Bunnyhop] Error loading checkpoint (%s)", error);
	
	if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl) && IsClientInGame(client))
	{
		decl String:cords[255];
		decl String:angles[255];
		
		SQL_FetchString(hndl, 0, cords, 255);
		SQL_FetchString(hndl, 1, angles, 255);
		
		if(StrEqual(cords, "0.000000:0.000000:0.000000") || StrEqual(angles, "0.000000:0.000000:0.000000"))
		{
			currentcp[client] = 0;
			wholecp[client] = 0;
		}
		else
		{
			decl String:cbuff[3][255];
			ExplodeString(cords, ":", cbuff, 3, 255);
			playercords[client][1][0] = StringToFloat(cbuff[0]);
			playercords[client][1][1] = StringToFloat(cbuff[1]);
			playercords[client][1][2] = StringToFloat(cbuff[2]);
			
			ExplodeString(angles, ":", cbuff, 3, 255);
			playerangles[client][1][0] = StringToFloat(cbuff[0]);
			playerangles[client][1][1] = StringToFloat(cbuff[1]);
			playerangles[client][1][2] = StringToFloat(cbuff[2]);
			currentcp[client] = 1;
			wholecp[client] = 1;
		}
	}
	else if(IsClientInGame(client))
	{
		decl String:query[255];
		decl String:steamid[64];
		GetClientAuthString(client, steamid, 64);

		Format(query, 255, "INSERT INTO checkpoints (map, steamid, cords, angles) VALUES ('%s', '%s', '0.000000:0.000000:0.000000', '0.000000:0.000000:0.000000')", map, steamid);
		SQL_TQuery(db, SQL_CheckCallback, query);
	}
}

public bool:FlipBool(bool:current)
{
	if(current)
		return false;
	else
		return true;
}

public OnSettingChanged(Handle:convar, const String:oldValue[], const String:newValue[])
{

	if(convar == cvarEnable)
	{
		if(newValue[0] == '1')
			g_Enable = true;
		else
			g_Enable = false;
	}
	if(convar == cvarTimer)
	{
		if(newValue[0] == '1')
			g_Timer = true;
		else
			g_Timer = false;
	}
	if(convar == cvarRestore)
	{
		if(newValue[0] == '1')
			g_Restore = true;
		else
			g_Restore = false;
	}
	if(convar == cvarNoblock)
	{
		if(newValue[0] == '1')
			g_Noblock = true;
		else
			g_Noblock = false;
	}
	if(convar == cvarTimerHudHint)
	{
		if(newValue[0] == '1')
			g_TimerHudHint = true;
		else
			g_TimerHudHint = false;
	}
	if(convar == cvarGravity)
	{
		if(newValue[0] == '1')
			g_Gravity = true;
		else
			g_Gravity = false;
	}
	if(convar == cvarNoFlash)
	{
		if(newValue[0] == '1')
		{
			HookEvent("player_blind" , Event_flashbang_detonate);
			g_NoFlash = true;
		}
		else
		{
			UnhookEvent("player_blind" , Event_flashbang_detonate);
			g_NoFlash = false;
		}
	}
	if(convar == cvarHealClient)
	{
		if(newValue[0] == '1')
		{
			HookEvent("player_hurt", Event_player_hurt);
			g_HealClient = true;
		}
		else
		{
			g_HealClient = false;
			UnhookEvent("player_hurt", Event_player_hurt, EventHookMode_Post);
		}
	}

	CfgWrite();
}

public OnClientPostAdminCheck(client)
{
	if(g_Enable && IsClientInGame(client) && !IsFakeClient(client))
	{
		currentcp[client] = 1;
		wholecp[client] = 1;

		if(g_Restore)
		{
			PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "ToHelp");
			decl String:query[255];
			new String:steamid[64];
			GetClientAuthString(client, steamid, 64);

			Format(query, sizeof(query), "SELECT cords, angles FROM 'checkpoints' WHERE steamid = '%s' AND map = '%s'", steamid, map);
			SQL_TQuery(db, SQL_SelectCpCallback, query, client);
		}
	}
}

public OnClientDisconnect(client)
{
	if(g_Enable)
	{
		if(g_Timer && TimerTimer[client] != INVALID_HANDLE)
		{
				CloseHandle(TimerTimer[client]);
				TimerTimer[client] = INVALID_HANDLE;
		}
		new current = currentcp[client];
		if(g_Restore && current > 0)
		{
			decl String:query[255];
			new timestamp = GetTime();
			new String:steamid[64];
			GetClientAuthString(client, steamid, 64);
			
			new String:cords[255];
			Format(cords, sizeof(cords), "'%f:%f:%f'",playercords[client][current][0],playercords[client][current][1],playercords[client][current][2]);
			new String:angles[255];
			Format(angles, sizeof(angles), "'%f:%f:%f'",playerangles[client][current][0],playerangles[client][current][1],playerangles[client][current][2]);
			Format(query, sizeof(query), "UPDATE checkpoints SET cords = %s, angles = %s, last_connect = %i WHERE map = '%s' AND steamid= '%s'", cords, angles, timestamp, map, steamid);
			SQL_TQuery(db, SQL_CheckCallback, query);
		}
	}
} 

public Action:Command_Say(client, args)
{
	//IsPlayerAlive(client) && 
	if(IsClientInGame(client))
	{
		new String:text[192];
		GetCmdArgString(text, sizeof(text));
		new startidx = 0;
		
		if(text[strlen(text)-1] == '"')
		{
		  text[strlen(text)-1] = '\0';
		  startidx = 1;
		}

		if(StrEqual(text[startidx], "!timerstop"))
			StopTimer(client);
		if(StrEqual(text[startidx], "!timerenable"))
			RestartTimer(client);
		if(StrEqual(text[startidx], "!hud"))
			ToogleHudOrHint(client);
		if(StrEqual(text[startidx], "!speed"))
			ToogleSpeed(client);
		if(StrEqual(text[startidx], "!all"))
			MenuAllUsers(client);
		if(StrEqual(text[startidx], "!wr") || StrEqual(text[startidx], "!top"))
			TopRecordsPanel(client);
		if(StrEqual(text[startidx], "!statsme") || StrEqual(text[startidx], "!me"))
			GetRankBySteam(client);
		if(StrEqual(text[startidx], "!block") || StrEqual(text[startidx], "!b"))
			ToogleBlock(client);
		if(StrEqual(text[startidx], "!scout") || StrEqual(text[startidx], "!sc"))
			ScoutClient(client);
		if(StrEqual(text[startidx], "!lowgrav") || StrEqual(text[startidx], "!lg"))
			ClientGravity(client,0.5);
		if(StrEqual(text[startidx], "!normalgrav") || StrEqual(text[startidx], "!ng"))
			ClientGravity(client,1.0);
		if(StrEqual(text[startidx], "!helpme"))
			HelpPanel(client);
		if(StrEqual(text[startidx], "!aboutme"))
			HelpPanel2ABOUT(client);

		if(g_Enable)
		{
			if(StrEqual(text[startidx], "!cp") || StrEqual(text[startidx], "!menu"))
				TeleMenu(client);
			if(StrEqual(text[startidx], "!next") || StrEqual(text[startidx], "!n"))
				TeleClient(client,1);
			if(StrEqual(text[startidx], "!prev") || StrEqual(text[startidx], "!p"))
				TeleClient(client,-1);
			if(StrEqual(text[startidx], "!save") || StrEqual(text[startidx], "!s"))
				SaveClientLocation(client);
			if(StrEqual(text[startidx], "!tele") || StrEqual(text[startidx], "!t"))
				TeleClient(client,0);
			if(StrEqual(text[startidx], "!clear") || StrEqual(text[startidx], "!c"))
				ClientClear(client);
			if(StrEqual(text[startidx], "!bhadmin") || StrEqual(text[startidx], "!bh"))
				CpAdmin(client, args); 
		}

		return Plugin_Continue;
	}

	return Plugin_Continue;
}

public Action:AdminDisableEnableTimer(client, args)
{
	new status = GetConVarInt(cvarTimer);
	
	if(status != 0)
	{
		SetConVarInt(cvarTimer, 0);
		CreateTimer(1.0, T_X_SetEraser);
		CreateTimer(1.0, T_Erase_OX_InMap);
		PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "Timer0ff");
		EmitSoundToAll("buttons/button17.wav", SND_CHANGEVOL, 10);
	
		if(OnTimer[client] == true)
		{
			TimerTimer[client] = INVALID_HANDLE;
			OnTimer[client] = false;
		}
	}
	else if(status != 1)
	{
		SetConVarInt(cvarTimer, 1);
		CreateTimer(1.0, T_X_SetEraser);
		CreateTimer(1.0, T_Set_OX_InMap);
		TimerTimer[client] = INVALID_HANDLE;
		OnTimer[client] = false;
		PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "Timer0n");
		EmitSoundToAll("buttons/button17.wav", SND_CHANGEVOL, 10);
	}
}

FuncNoClip(client)
{
	new MoveType:movetype = GetEntityMoveType(client);
	if (movetype != MOVETYPE_NOCLIP)
	{
		NoClipOnOff = true;
		SetEntityMoveType(client, MOVETYPE_NOCLIP);
	}
	else
	{
		SetEntityMoveType(client, MOVETYPE_WALK);
		NoClipOnOff = false;
	}
}

public ToogleBlock(client)
{    
	if(g_Noblock && GetClientTeam(client) != 0)
	{
		if(blocking[client])
		{
			SetEntData(client, FindSendPropOffs("CBaseEntity", "m_CollisionGroup"), 2, 4, true);
			blocking[client] = false;
			PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "BlockingDisabled");
		}
		else
		{
			SetEntData(client, FindSendPropOffs("CBaseEntity", "m_CollisionGroup"), 5, 4, true);
			blocking[client] = true;
			PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "BlockingEnabled");
		}
	}
	else
	{
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "NoblockDisabled");
		blocking[client] = false;
	}	
}

public ToogleHudOrHint(client)
{    
	if(UserTimerHudOrHint[client])
	{
		UserTimerHudOrHint[client] = false;
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "YourTimerHintText");
	}
	else
	{
		UserTimerHudOrHint[client] = true;
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "YourTimerHudHint");
	}
}

public ToogleSpeed(client)
{    
	if(UserTimerSpeed[client])
	{
		UserTimerSpeed[client] = false;
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "YourTimerSpeedDisable");
	}
	else
	{
		UserTimerSpeed[client] = true;
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "YourTimerSpeedEnable");
	}
}

public ScoutClient(client)
{
	new limit = GetConVarInt(cvarScoutLimit);
	if(limit == 0)
	{
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "ScoutDisabled");
	}

	else

	if(scouts[client] < limit)
	{
		GivePlayerItem(client, "weapon_scout");
		scouts[client] ++;
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "ScoutGiven");
	}
	else
	{
		EmitSoundToClient(client,"buttons/button2.wav", SND_CHANGEVOL, 10);
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "ScoutLimit");
	}
}

public ClientGravity(client, Float:amount)
{
	if(g_Gravity && GetClientTeam(client) != 0)
	{
		SetEntityGravity(client, amount);
		
		if(amount >= 1.0)
		{
			PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "GravityNormal");
			g_ClientInGravity[client] = false;
		}
		else
		{
			PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "GravityLow");
			g_ClientInGravity[client] = true;
		}
	}
	else
	{
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "GravityDisabled");
		EmitSoundToClient(client,"buttons/button2.wav", SND_CHANGEVOL, 10);
	}
}

public SaveClientLocation(client)
{
	if(!OnTimer[client])
	{
		if(GetEntDataEnt2(client, FindSendPropOffs("CBasePlayer", "m_hGroundEntity")) != -1)
		{
			new current = currentcp[client];
			new whole = wholecp[client];
			new limit = GetConVarInt(cvarCpLimit);
		
			if(current < limit)
			{
				GetClientAbsOrigin(client,playercords[client][current+1]);
				GetClientAbsAngles(client,playerangles[client][current+1]);
				currentcp[client] ++;
				current = currentcp[client];
				whole = wholecp[client];
			
				if (current > whole)
				{
					wholecp[client] = current;
					whole = current;
				}
				TE_SetupBeamRingPoint(playercords[client][current],120.0,400.0,Plasmabeam,0,0,0,1.0,60.0,0.0,{0, 0, 255, 255},0,0);
				TE_SendToClient(client);
				EmitSoundToClient(client,"buttons/button9.wav");
				PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t  ", "CpSaved", current, GetConVarInt(cvarCpLimit));
			}
			else
      
				PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "CpLimit");
		}
		else
		{
			PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "NotOnGround");
			EmitSoundToClient(client, "ambient/3dmeagle.wav", SND_CHANGEVOL, 10);
		}
	}
	else
	{
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "TimerActive");
		EmitSoundToClient(client,"buttons/button2.wav", SND_CHANGEVOL, 10);
	}
}

public TeleClient(client,pos)
{
	if(!OnTimer[client])
	{
		new current = currentcp[client];
		new whole = wholecp[client];
		
		if(current == whole && pos == 1)
		{
			currentcp[client] = 0;
			current = 0;
		}
		
		if(current == 1  && pos == -1)
		{
			currentcp[client] = whole+1;
			current = whole+1;
		}
		
		new actual = current+pos;
		if((actual > GetConVarInt(cvarCpLimit)) ||
		(actual<1) ||
		(playercords[client][actual][0] == 0) &&
		(playercords[client][actual][1] == 0) &&
		(playercords[client][actual][2] == 0))
		{
			PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "CpNotFound");
			EmitSoundToClient(client,"buttons/button2.wav", SND_CHANGEVOL, 10);
		}
		else
		{
			TeleportEntity(client, playercords[client][actual],playerangles[client][actual],NULL_VECTOR);
			PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "CpTeleported", actual, whole);
			currentcp[client] += pos;
			EmitSoundToClient(client,"player/suit_sprint.wav");
			TE_SetupBeamRingPoint(playercords[client][actual],120.0,400.0,Plasmabeam,0,0,0,1.0,60.0,0.0,{255, 255, 0, 255},0,0);
			TE_SendToClient(client);
		}
	}
	else
	{
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "TimerActive");
		EmitSoundToClient(client,"buttons/button2.wav", SND_CHANGEVOL, 10);
	}
}

public TeleMenu(client)
{
	decl String:buffer[256];
	new Handle:menu = CreateMenu(TeleMenuHandler);

	Format(buffer, sizeof(buffer), "Bunnyhop : %T", "menu_3agolovok", client);
	SetMenuTitle(menu, buffer);
	Format(buffer, sizeof(buffer), "%T", "coxpaHuTb_4p", client);
	AddMenuItem(menu, "!save", buffer);
	Format(buffer, sizeof(buffer), "%T", "TeJIe_4p", client);
	AddMenuItem(menu, "!tele", buffer);
	Format(buffer, sizeof(buffer), "%T", "TeJIe_4p_cJIeDyIoIII", client);
	AddMenuItem(menu, "!next", buffer);
	Format(buffer, sizeof(buffer), "%T", "TeJIe_4p_IIpeDuDyIII", client);
	AddMenuItem(menu, "!prev", buffer);
	Format(buffer, sizeof(buffer), "%T", "CTepeTb_Bce_4p", client);
	AddMenuItem(menu, "!clear", buffer);

	SetMenuExitButton(menu, true);
	SetMenuOptionFlags(menu, MENUFLAG_BUTTON_EXIT);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public TeleMenuHandler(Handle:menu, MenuAction:action, param1, param2){
	if(action == MenuAction_Select){
		switch(param2){
			case 0:{
				SaveClientLocation(param1);
			}
			case 1: {
				TeleClient(param1,0);
			}
			case 2: {
				TeleClient(param1,1);
			}
			case 3:{
				TeleClient(param1,-1);
			}
			case 4: {
				ClientClear(param1);
				TeleMenu(param1);
			}
		}
		TeleMenu(param1);
	}
	else if(action == MenuAction_End)
	CloseHandle(menu);
}

public ClientClear(client)
{
	currentcp[client] = 0;
	wholecp[client] = 0;
    
	new limit = GetConVarInt(cvarCpLimit);
	
	for(new i = 0; i <= limit; i++)
	{
		playercords[client][i][0]=0.0;
		playercords[client][i][1]=0.0;
		playercords[client][i][2]=0.0;
		playerangles[client][i][0]=0.0;
		playerangles[client][i][1]=0.0;
		playerangles[client][i][2]=0.0;
	}

	PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "Cleared");
	EmitSoundToClient(client,"buttons/button19.wav", SND_CHANGEVOL, 10);
}


public Action:Event_player_spawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new String:Clientnames[64];
	GetClientName(client, Clientnames, sizeof(Clientnames));

	if(g_Noblock)
	{
		SetEntData(client, FindSendPropOffs("CBaseEntity", "m_CollisionGroup"), 2, 4, true);
		blocking[client] = false;
	}  
	if(g_HealClient)
		SetEntData(client, FindSendPropOffs("CBasePlayer", "m_iHealth"), 100);
		
	if(UserTimerActive[client] == false)
	{
		UserTimerActive[client] = true;
	}

	MiniUpdate(client);
}

public Action:Event_player_hurt(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new damage = GetEventInt(event, "damage");
	SetEntData(client, FindSendPropOffs("CBasePlayer", "m_iHealth"), 100 + damage);
} 

public Action:Event_player_jump(Handle:event,const String:name[],bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	g_ClientJumps[client]++;
}

public Action:Event_flashbang_detonate(Handle:event,const String:name[],bool:dontBroadcast)
{
	if(g_NoFlash)
	{
		new client = GetClientOfUserId(GetEventInt(event,"userid"));
		SetEntDataFloat(client,FindSendPropOffs("CCSPlayer", "m_flFlashMaxAlpha"),0.0);
	}
}

public Action:Event_player_footstep(Handle:event,const String:name[],bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new String:username[32];
	GetClientName(client, username, sizeof(username));
	
	new String:time[32];
	new miliseconds = g_ClientTime[client]%10;
	new seconds = g_ClientTime[client]/10%60;
	new minutes = g_ClientTime[client]/600%60;
	new hours = g_ClientTime[client]/36000;
	if(g_ClientTime[client] > 599)
		Format(time, sizeof(time), "%i min %i.%i sec", minutes, seconds, miliseconds);
	else if(g_ClientTime[client] > 35999)
		Format(time, sizeof(time), "%i h %i min %i.%i sec", hours, minutes, seconds, miliseconds);
	else
		Format(time, sizeof(time), "%i.%i sec", seconds, miliseconds);

	if(g_Timer && g_NullCoords == false)
	{
		new Float:pcordsbeam[3];
		new Float:pcords[3];
		GetClientAbsOrigin(client,pcordsbeam);
		GetClientAbsOrigin(client,pcords);

		if(TimerTimer[client] == INVALID_HANDLE && OnTimer[client] == false && UserTimerActive[client] == true)
		{
			if((pcords[0] >= g_MapBeginCoords[0]-100 &&
				pcords[0] <= g_MapBeginCoords[0]+100) &&
				(pcords[1] >= g_MapBeginCoords[1]-100 &&
				pcords[1] <= g_MapBeginCoords[1]+100) && 
				(pcords[2] >= g_MapBeginCoords[2]-100 &&
				pcords[2] <= g_MapBeginCoords[2]+100))
			{
					g_ClientTime[client] = 0;
					g_ClientJumps[client] = 0;
					g_ClientSpeedkmh[client] = 0;
					g_ClientSpeedunts[client] = 0;

					TimerTimer[client] = CreateTimer(0.1, TimerRoute, client, TIMER_REPEAT);
					TE_SetupBeamRingPoint(pcordsbeam,150.0,400.0,Plasmabeam,0,0,0,1.0,80.0,0.0,{0,200,0,255},0,0);
					TE_SendToAll();
					EmitSoundToClient(client,"buttons/button17.wav");
					PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "TimerStarted");
					OnTimer[client] = true;
					UserTimerActive[client] = true;
			}
		}
		else if(TimerTimer[client] != INVALID_HANDLE && OnTimer[client] == true && UserTimerActive[client] == true)
		{
			if((pcords[0] >= g_MapEndCoords[0]-100 &&
			pcords[0] <= g_MapEndCoords[0]+100) &&
			(pcords[1] >= g_MapEndCoords[1]-100 &&
			pcords[1] <= g_MapEndCoords[1]+100) &&
			(pcords[2] >= g_MapEndCoords[2]-100 &&
			pcords[2] <= g_MapEndCoords[2]+100))
			{
				TimerTimer[client] = INVALID_HANDLE;
				OnTimer[client] = false;
				PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "Complete", username, time, g_ClientJumps[client]);
				EmitSoundToClient(client,"buttons/button17.wav");
				TE_SetupBeamRingPoint(pcordsbeam,150.0,600.0,Plasmabeam,0,0,0,5.0,80.0,0.0,{255,125,0,255},0,0);
				TE_SendToAll();
				g_UserMapFinisCount[client]++;

				if (db != INVALID_HANDLE)
				{
					new String:query_getinfo[500];
					new String:usersteamid[64];
					GetClientAuthString(client, usersteamid, sizeof(usersteamid));
					Format(query_getinfo, sizeof(query_getinfo), "SELECT time FROM usersstats WHERE map = '%s' AND steamid = '%s' AND time NOT LIKE '-1' AND jumps NOT LIKE '-1'", map, usersteamid);
					SQL_TQuery(db, SQL_CheckForRecord, query_getinfo, client);

				}
				else
				{
					PrintToServer("[Bunnyhop] Database not available to update player info...");
				}
			}
		}
	}
}

public Action:TimerRoute(Handle:timer, any:client)
{
	if(client != 0 && IsClientInGame(client) && IsPlayerAlive(client))
	{		
		if(OnTimer[client] == true && UserTimerActive[client] == true)
		{
			g_ClientTime[client]++;
			StopSound(client, SNDCHAN_STATIC, "UI/hint.wav");

			new Float:vel[3];
			new speedunts;
			new speedkmh;

			GetEntPropVector(client, Prop_Data, "m_vecVelocity", vel);
			speedunts = RoundToFloor(SquareRoot (Pow(vel[0], 2.0) + Pow(vel[1], 2.0) + Pow(vel[2],2.0)));
			speedkmh = RoundToFloor(SquareRoot (Pow(vel[0], 2.0) + Pow(vel[1], 2.0) + Pow(vel[2],2.0)) * 0.06858);

			if (speedunts > g_ClientSpeedunts[client])
			{
				g_ClientSpeedunts[client] = speedunts;
				g_ClientSpeedkmh[client] = speedkmh;
			}

			new String:formathudhint[255];
			new String:time[32];
			new miliseconds = g_ClientTime[client]%10;
			new seconds = g_ClientTime[client]/10%60;
			new minutes = g_ClientTime[client]/600%60;
			new hours = g_ClientTime[client]/36000;

			if(g_ClientTime[client] > 599)
				Format(time, sizeof(time), "%i min : %i.%i sec", minutes, seconds, miliseconds);
			else if(g_ClientTime[client] > 35999)
				Format(time, sizeof(time), "%i : %i min : %i.%i sec", hours, minutes, seconds, miliseconds);
			else
				Format(time, sizeof(time), "%i.%i sec", seconds, miliseconds);


			if(g_TimerHudHint == true)
			{
				if(UserTimerHudOrHint[client] == true)
				{
					if(UserTimerSpeed[client] == true)
					{
						Format(formathudhint, sizeof(formathudhint), "%t : %s\n%t : %i\n%t", "utime", time, "ujumps", g_ClientJumps[client], "uspeed", speedunts, speedkmh);
						new Handle:hBuffer = StartMessageOne("KeyHintText", client); 
						BfWriteByte(hBuffer, 1); 
						BfWriteString(hBuffer, formathudhint);
						EndMessage();
					}
					else
					{
						Format(formathudhint, sizeof(formathudhint), "%t : %s\n%t : %i", "utime", time, "ujumps", g_ClientJumps[client]);
						new Handle:hBuffer = StartMessageOne("KeyHintText", client); 
						BfWriteByte(hBuffer, 1); 
						BfWriteString(hBuffer, formathudhint);
						EndMessage();
					}
				}
				else
				{
					if(UserTimerSpeed[client] == true)
					{
						PrintHintText(client,"%t : %s\n%t : %i\n%t", "utime", time,"ujumps",g_ClientJumps[client], "uspeed", speedunts, speedkmh);
					}
					else
					{
						PrintHintText(client,"%t : %s\n%t : %i", "utime", time,"ujumps",g_ClientJumps[client]);
					}
				}
			}
			else
			{
				if(UserTimerHudOrHint[client] == true)
				{
					if(UserTimerSpeed[client] == true)
					{
						Format(formathudhint, sizeof(formathudhint), "%t : %s\n%t : %i\n%t", "utime", time, "ujumps", g_ClientJumps[client], "uspeed", speedunts, speedkmh);
						new Handle:hBuffer = StartMessageOne("KeyHintText", client); 
						BfWriteByte(hBuffer, 1); 
						BfWriteString(hBuffer, formathudhint);
						EndMessage();
					}
					else
					{
						Format(formathudhint, sizeof(formathudhint), "%t : %s\n%t : %i", "utime", time, "ujumps", g_ClientJumps[client]);
						new Handle:hBuffer = StartMessageOne("KeyHintText", client); 
						BfWriteByte(hBuffer, 1); 
						BfWriteString(hBuffer, formathudhint);
						EndMessage();
					}
				}
				else
				{
					if(UserTimerSpeed[client] == true)
					{
						PrintHintText(client,"%t : %s\n%t : %i\n%t", "utime", time,"ujumps",g_ClientJumps[client], "uspeed", speedunts, speedkmh);
					}
					else
					{
						PrintHintText(client,"%t : %s\n%t : %i", "utime", time,"ujumps",g_ClientJumps[client]);
					}
				}
			}
		}
		else
		{
			TimerTimer[client] = INVALID_HANDLE;
			OnTimer[client] = false;
					
			return Plugin_Stop;
		}

		return Plugin_Continue;
	}
	else
	{
		TimerTimer[client] = INVALID_HANDLE;
		OnTimer[client] = false;
		
		return Plugin_Stop;
	}
}

public StopTimer(client)
{
	if(!g_Timer)
	{
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "TimerNeDostypen");
		EmitSoundToClient(client, "buttons/button2.wav", SND_CHANGEVOL, 10);
	}
	else if (g_Timer)
	{
		if(client != 0 && IsClientInGame(client) && IsPlayerAlive(client))
		{
			if(UserTimerActive[client] == true || OnTimer[client] == true)
			{
				TimerTimer[client] = INVALID_HANDLE;
				OnTimer[client] = false;
				UserTimerActive[client] = false;
				PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "TimerStoppedByUser");
				EmitSoundToClient(client,"buttons/button17.wav", SND_CHANGEVOL, 10);
			}
			else
			{
				PrintToChat(client, "\x01[\x03Bunnyhop\x01]  \x03Ваш таймер в данное время не активен");

			}
		}
		else
		{
			PrintToChat(client, "\x01[\x03Bunnyhop\x01]  \x03Вы должны быть в игре!");
		}
	}
}

public RestartTimer(client)
{
	if(!g_Timer)
	{
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "TimerNeDostypen");
		EmitSoundToClient(client, "buttons/button2.wav", SND_CHANGEVOL, 10);
	}
	else if(g_Timer)
	{
		if(client != 0 && IsClientInGame(client) && IsPlayerAlive(client))
		{
			if(UserTimerActive[client] == false || OnTimer[client] == false)
			{
				TimerTimer[client] = INVALID_HANDLE;
				UserTimerActive[client] = true;
				PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "TimerEnabledByUser");
				EmitSoundToClient(client, "buttons/button17.wav", SND_CHANGEVOL, 10);
			}
			else
			{
				PrintToChat(client, "\x01[\x03Bunnyhop\x01]  \x03Ваш таймер в данное время уже активен");
			}
		}
		else
		{
			PrintToChat(client, "\x01[\x03Bunnyhop\x01]  \x03Вы должны быть в игре!");
		}
	}
}

public SQL_CheckCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if(hndl == INVALID_HANDLE)
	LogError("[Bunnyhop] Error database (%s)", error);
}

public SQL_CheckForRecord(Handle:owner, Handle:hndl, const String:error[], any:client)
{
	if(hndl == INVALID_HANDLE)
		LogError("[Bunnyhop] Error loading users stats (%s)", error);
	new String:username[32];
	new String:usersteamid[64];
	GetClientName(client, username, sizeof(username));
	GetClientAuthString(client, usersteamid, sizeof(usersteamid));
	new statstime;

	if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl))
	{
		statstime = SQL_FetchInt(hndl, 0);

		if(g_ClientTime[client] >= statstime)
		{
			MiniUpdate(client);
		}
		else if(g_ClientTime[client] <= statstime)
		{
			UpdateUserStats(client);
		}
	}
	else
	{
		decl String:query_insert[512];
		Format(query_insert, sizeof(query_insert), "INSERT INTO usersstats (name, steamid, time, jumps, speedkmh, speedunts, map, map_fc) VALUES ('%s', '%s', '%i', '%i', '%i', '%i', '%s', '%i')", username, usersteamid, g_ClientTime[client], g_ClientJumps[client], g_ClientSpeedkmh[client], g_ClientSpeedunts[client], map, g_UserMapFinisCount[client]);
		SQL_TQuery(db, SQL_CheckCallback, query_insert);
		UserAddedIndb[client] = 1;
	}
}

public MiniUpdate(client)
{
	if (db != INVALID_HANDLE)
	{
		new String:query_select[500];
		new String:select_steamid[64];
		GetClientAuthString(client, select_steamid, sizeof(select_steamid));	
		
		Format(query_select, sizeof(query_select), "SELECT name, speedkmh, speedunts, map_fc FROM usersstats WHERE map = '%s' AND steamid = '%s'", map, select_steamid);
		SQL_TQuery(db, SQL_MiniUpdate, query_select, client);
	}
	else
	{
		PrintToServer("[Bunnyhop] Database not available");
	}
}

public SQL_MiniUpdate(Handle:owner, Handle:hndl, const String:error[], any:client)
{
	if(hndl == INVALID_HANDLE)
		LogError("[Bunnyhop] Error loading users stats (%s)", error);
	
	if (IsClientInGame(client) && !IsFakeClient(client))
	{
		if(SQL_HasResultSet(hndl))
		{
			if(SQL_FetchRow(hndl))
			{
				decl String:query_update[1024];
				decl String:upd_name[64];
				decl String:upd_steamid[64];
				GetClientAuthString(client, upd_steamid, sizeof(upd_steamid));	
				GetClientName(client, upd_name, sizeof(upd_name));

				Format(query_update, sizeof(query_update), "UPDATE usersstats SET name = '%s', speedkmh = '%i', speedunts = '%i', map_fc = '%i' WHERE map = '%s' AND steamid = '%s'", upd_name, g_ClientSpeedkmh[client], g_ClientSpeedunts[client], g_UserMapFinisCount[client], map, upd_steamid);
				SQL_TQuery(db, SQL_CheckCallback, query_update);
			}
			else
			{
				//PrintToServer("USER NOT FOUND");
			}
		}
		else
		{
			//PrintToServer("NOT FOUND RESULTS");
		}
	}
	else
	{
		//PrintToServer("[Bunnyhop] not found clients to update in SQL...");
	}
}


public UpdateUserStats(client)
{
	if (db != INVALID_HANDLE)
	{
		new String:query_select[500];
		new String:select_steamid[64];
		GetClientAuthString(client, select_steamid, sizeof(select_steamid));	
		
		Format(query_select, sizeof(query_select), "SELECT name, time, jumps, speedkmh, speedunts, map_fc FROM usersstats WHERE map = '%s' AND steamid = '%s'", map, select_steamid);
		SQL_TQuery(db, SQL_UpdateUserStats, query_select, client);
	}
	else
	{
		PrintToChat(client, "[Bunnyhop] Database not available");
	}
}

public SQL_UpdateUserStats(Handle:owner, Handle:hndl, const String:error[], any:client)
{
	if(hndl == INVALID_HANDLE)
		LogError("[Bunnyhop] Error loading users stats (%s)", error);
	
	if (IsClientInGame(client) && !IsFakeClient(client))
	{
		if(SQL_HasResultSet(hndl))
		{
			if(SQL_FetchRow(hndl))
			{
				decl String:query_update[1024];
				decl String:upd_name[64];
				decl String:upd_steamid[64];
				
				GetClientName(client, upd_name, sizeof(upd_name));
				GetClientAuthString(client, upd_steamid, sizeof(upd_steamid));			


				Format(query_update, sizeof(query_update), "UPDATE usersstats SET name = '%s', time = '%i', jumps = '%i', speedkmh = '%i', speedunts = '%i', map_fc = '%i' WHERE map = '%s' AND steamid = '%s'", upd_name, g_ClientTime[client], g_ClientJumps[client], g_ClientSpeedkmh[client], g_ClientSpeedunts[client],  g_UserMapFinisCount[client], map, upd_steamid);
				SQL_TQuery(db, SQL_CheckCallback, query_update);
			}
			else
			{
				decl String:ins_name[64];
				decl String:ins_steamid[64];
				decl ins_jumps;
				decl ins_time;
				decl ins_speedunts;
				decl ins_speedkmh;
				decl ins_map_fc;

				ins_time = g_ClientTime[client];
				ins_jumps = g_ClientJumps[client];
				ins_speedkmh = g_ClientSpeedkmh[client];
				ins_speedunts = g_ClientSpeedunts[client];
				ins_map_fc = g_UserMapFinisCount[client];

				GetClientName(client, ins_name, sizeof(ins_name));
				GetClientAuthString(client, ins_steamid, sizeof(ins_steamid));	
				decl String:query_insert[512];
				Format(query_insert, sizeof(query_insert), "INSERT INTO usersstats (name, steamid, time, jumps, speedkmh, speedunts, map, map_fc) VALUES ('%s', '%s', '%i', '%i', '%i', '%i', '%s', '%i')", ins_name, ins_steamid, ins_time, ins_jumps, ins_speedkmh, ins_speedunts, map, ins_map_fc);
				SQL_TQuery(db, SQL_CheckCallback, query_insert);
				UserAddedIndb[client] = 1;
			}
		}
		else
		{
			PrintToServer("NOT FOUND RESULTS");
		}
	}
	else
	{
		PrintToServer("[Bunnyhop] not found clients to update in SQL...");
	}
}


public TopRecordsPanel(client)
{
	if (db != INVALID_HANDLE)
	{
		new String:query_getinfo[500];
		Format(query_getinfo, sizeof(query_getinfo), "SELECT name, time, jumps FROM usersstats WHERE map = '%s' ORDER BY time ASC LIMIT 10", map);
		SQL_TQuery(db, SQL_TopRecordsPanel, query_getinfo, client);
	}
	else
	{
		PrintToChat(client, "[Bunnyhop] Database not available");
	}
}

public SQL_TopRecordsPanel(Handle:owner, Handle:hndl, const String:error[], any:client)
{
	if(hndl == INVALID_HANDLE)
		LogError("[Bunnyhop] Error loading users stats (%s)", error);

	new Handle:Panel = CreatePanel();
	new String:title[100];
	Format(title , sizeof(title), "[Bunnyhop] top 10 на карте : %s\n", map);
	SetPanelTitle(Panel, title);

	new String:items[128];
	new String:statsname[64];
	new String:time[32];
	new statstime;
	new statsjumps;
	new it;

	if(SQL_HasResultSet(hndl))
	{
		while(SQL_FetchRow(hndl))
		{
			it++;
			SQL_FetchString(hndl, 0, statsname, sizeof(statsname));
			statstime = SQL_FetchInt(hndl, 1);
			statsjumps = SQL_FetchInt(hndl, 2);

			new miliseconds = statstime%10;
			new seconds = statstime/10%60;
			new minutes = statstime/600%60;
			new hours = statstime/36000;
			if(statstime > 599)
				Format(time, sizeof(time), "%i min %i.%i sec", minutes, seconds, miliseconds);
			else if(statstime > 35999)
				Format(time, sizeof(time), "%i h %i min %i.%i sec", hours, minutes, seconds, miliseconds);
			else
				Format(time, sizeof(time), "%i.%i sec", seconds, miliseconds);

			Format(items,sizeof(items), "[%i] %s (%s) [Jumps %i]", it, statsname, time, statsjumps);
			DrawPanelText(Panel, items);
		}
	}

	DrawPanelItem(Panel, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
	Format(items , sizeof(items), "Выход");
	DrawPanelItem(Panel, items);
	SendPanelToClient(Panel, client, SQL_RecordsPanelHandler, MENU_TIME_FOREVER);
	
	CloseHandle(Panel);
}

public SQL_RecordsPanelHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			Panel = INVALID_HANDLE;
		}
	}
}


public MenuAllUsers(client)
{
	if (db != INVALID_HANDLE)
	{
		new String:query_getinfo[500];
		Format(query_getinfo, sizeof(query_getinfo), "SELECT name FROM usersstats WHERE map = '%s' AND map_fc NOT LIKE '-1' ORDER BY time ASC", map);
		SQL_TQuery(db, SQL_MenuAllUsers, query_getinfo, client);
	}
	else
	{
		PrintToChat(client, "[Bunnyhop] Database not available");
	}
}



public SQL_MenuAllUsers(Handle:owner, Handle:hndl, const String:error[], any:client)
{
	new Handle:menu = CreateMenu(SQL_MenuAllUsersHandler);
	decl String:title[300];
	Format(title, sizeof(title), "[Bunnyhop] все кто прошол : %s", map);
	SetMenuTitle(menu, title);
	new String:statsname[255];

	if(SQL_HasResultSet(hndl))
	{
		while(SQL_FetchRow(hndl))
		{
			new String:items[300];
			SQL_FetchString(hndl, 0, statsname, sizeof(statsname));

			Format(items,sizeof(items), "%s", statsname);
			AddMenuItem(menu, items, items, ITEMDRAW_DEFAULT);
		}
	}
	
	else
	{
		Format(title, sizeof(title), "[Bunnyhop] все кто прошол : %s", map);
		SetMenuTitle(menu, title);
		new String:items[300];
		Format(items,sizeof(items), " ");
		AddMenuItem(menu, " ", items, ITEMDRAW_SPACER);
		Format(items,sizeof(items), "Эту карту ещё никто не проходил до конца");
		AddMenuItem(menu, "", items, ITEMDRAW_DISABLED);
		SetMenuExitButton(menu, true);
	}

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public SQL_MenuAllUsersHandler(Handle:menu, MenuAction:action, param1, param2)
{
	new client = param1;
	if (action == MenuAction_Select)
	{
		GetMenuItem(menu, param2, g_SelectedName, sizeof(g_SelectedName));
		GetRankByName(client);
		new String:query_getinfo[500];
		Format(query_getinfo, sizeof(query_getinfo), "SELECT name, steamid, time, jumps, speedkmh, speedunts, map_fc FROM usersstats WHERE map = '%s' AND name = '%s'", map, g_SelectedName);
		SQL_TQuery(db, SQL_UserStatsPanel, query_getinfo, client);

	}

	if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack)
		{
			MenuAllUsers(client);
		}
	}

	else if(action == MenuAction_End)
	CloseHandle(menu);
}


public GetRankByName(client)
{
	if (db != INVALID_HANDLE)
	{
		new String:query[500];
		Format(query, sizeof(query), "SELECT * FROM usersstats WHERE map = '%s' ORDER BY time ASC", map);
		SQL_TQuery(db, SQL_GetRankByName, query, client);
	}
	else
	{
		PrintToChat(client, "[Bunnyhop] Database not available");
	}

}

public SQL_GetRankByName(Handle:owner, Handle:hndl, const String:error[], any:client)
{
	if(hndl == INVALID_HANDLE)
		LogError("[Bunnyhop] Error loading users stats (%s)", error);

	decl String:qname[255];
	new qrow;
	new qtotalrow;

	if(SQL_HasResultSet(hndl))
	{
		while(SQL_FetchRow(hndl))
		{
			qrow++;
			qtotalrow = SQL_GetRowCount(hndl);
			SQL_FetchString(hndl, 0, qname, sizeof(qname));

			if(StrEqual(qname, g_SelectedName))
			{
				g_Rank = qrow;
				g_Total = qtotalrow;
			}
		}
	}

	else
	{
		PrintToServer("[Bunnyhop] not found results in database...\n");
	}
}

public GetRankBySteam(client)
{
	if (db != INVALID_HANDLE)
	{
		new String:query[500];
		Format(query, sizeof(query), "SELECT * FROM usersstats WHERE map = '%s' ORDER BY time ASC", map);
		SQL_TQuery(db, SQL_GetRankBySteam, query, client);
	}
	else
	{
		PrintToChat(client, "[Bunnyhop] Database not available");
	}

}

public SQL_GetRankBySteam(Handle:owner, Handle:hndl, const String:error[], any:client)
{
	if(hndl == INVALID_HANDLE)
		LogError("[Bunnyhop] Error loading users stats (%s)", error);
	
	new String:usersteamid[255];
	GetClientAuthString(client, usersteamid, sizeof(usersteamid));
	decl String:qsteam[255];
	new qrow;
	new qtotalrow;

	if(SQL_HasResultSet(hndl))
	{
		while(SQL_FetchRow(hndl))
		{
			qrow++;
			qtotalrow = SQL_GetRowCount(hndl);
			SQL_FetchString(hndl, 1, qsteam, sizeof(qsteam));

			if(StrEqual(qsteam, usersteamid))
			{
				g_Rank = qrow;
				g_Total = qtotalrow;
			}
		}
	}
	UserStatsPanel(client);
}


public UserStatsPanel(client)
{
	if (db != INVALID_HANDLE)
	{
		new String:usersteamid[255];
		GetClientAuthString(client, usersteamid, sizeof(usersteamid));
		new String:query_getinfo[500];
		Format(query_getinfo, sizeof(query_getinfo), "SELECT name, steamid, time, jumps, speedkmh, speedunts, map_fc FROM usersstats WHERE map = '%s' AND steamid = '%s' ORDER BY time ASC LIMIT 1", map, usersteamid);
		SQL_TQuery(db, SQL_UserStatsPanel, query_getinfo, client);
	}
	else
	{
		PrintToChat(client, "[Bunnyhop] Database not available");
	}

}

public SQL_UserStatsPanel(Handle:owner, Handle:hndl, const String:error[], any:client)
{
	if(hndl == INVALID_HANDLE)
		LogError("[Bunnyhop] Error loading users stats (%s)", error);

	EmitSoundToClient(client,"buttons/button17.wav", SND_CHANGEVOL, 10);	
	new Handle:panel = CreatePanel();
	new String:title[255];
	new String:items[255];
	new String:time[255];
	new String:statsname[255];
	new String:statssteamid[255];
	new statstime;
	new statsjumps;
	new statsspeedkmh;
	new statsspeedunts;
	new statsmap_fc;

	new String:username[255];
	new String:usersteamid[255];
	new String:userjumps[255];
	new String:usertime[255];
	new String:usermaxspeed[255];
	new String:foruserinfo[1024];

	Format(title , sizeof(title), "[Bunnyhop] Статистика :");
	SetPanelTitle(panel, title);
	DrawPanelText(panel, "----------------------------------");
	DrawPanelItem(panel, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
	
	if(SQL_HasResultSet(hndl))
	{
		if(SQL_FetchRow(hndl))
		{
			SQL_FetchString(hndl, 0, statsname, sizeof(statsname));
			SQL_FetchString(hndl, 1, statssteamid, sizeof(statssteamid));
			statstime = SQL_FetchInt(hndl, 2);
			statsjumps = SQL_FetchInt(hndl, 3);
			statsspeedkmh = SQL_FetchInt(hndl, 4);
			statsspeedunts = SQL_FetchInt(hndl, 5);
			statsmap_fc = SQL_FetchInt(hndl, 6);
			
			new miliseconds = statstime%10;
			new seconds = statstime/10%60;
			new minutes = statstime/600%60;
			new hours = statstime/36000;
			if(statstime > 599)
				Format(time, sizeof(time), "%i min %i.%i sec", minutes, seconds, miliseconds);
			else if(statstime > 35999)
				Format(time, sizeof(time), "%i h %i min %i.%i sec", hours, minutes, seconds, miliseconds);
			else
				Format(time, sizeof(time), "%i.%i sec", seconds, miliseconds);
			
			Format(username, sizeof(username), "%t : %s", "UserStats_username", statsname);
			Format(usersteamid, sizeof(usersteamid), "%t : %s", "UserStats_steam", statssteamid);
			Format(userjumps, sizeof(userjumps), "%t : %i", "UserStats_userjumps", statsjumps);  
			Format(usertime, sizeof(usertime), "%t : %s", "UserStats_usertime", time);
			Format(usermaxspeed, sizeof(usermaxspeed), "%t", "UserStats_maxspeed", statsspeedunts, statsspeedkmh);
			Format(foruserinfo, sizeof(foruserinfo), "%t", "UserStats_foruserinfo", g_Rank, g_Total, statsmap_fc);

			DrawPanelText(panel, username);
			DrawPanelText(panel, usersteamid);
			DrawPanelText(panel, usertime);
			DrawPanelText(panel, userjumps);
			DrawPanelText(panel, usermaxspeed);
			DrawPanelItem(panel, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
			DrawPanelText(panel, "----------------------------------");
			DrawPanelItem(panel, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
			DrawPanelText(panel, foruserinfo);
		}
		else if(!SQL_FetchRow(hndl))
		{
			Format(items,sizeof(items), "Об игроке ничего не найдено в базе данных\nили он ещё не прошол эту карту");
			DrawPanelText(panel, items);
		}
	}
	else
	{
		Format(items,sizeof(items), "Об игроке ничего не найдено в базе данных\nили он ещё не прошол эту карту");
		DrawPanelText(panel, items);
	}

	DrawPanelItem(panel, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
	Format(items , sizeof(items), "Выход");
	DrawPanelItem(panel, items);

	SendPanelToClient(panel, client, SQL_RecordsPanelHandler, MENU_TIME_FOREVER);
	CloseHandle(panel);
}

public UserStatsPanelHandler(Handle:panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			panel = INVALID_HANDLE;
		}
	}
}


public Action:CpAdmin(client, args)
{
	if(GetUserAdmin(client) != INVALID_ADMIN_ID)
	{
		decl String:buffer[1024];
		new Handle:menu = CreateMenu(AdminMenuHandler);
		Format(buffer, sizeof(buffer), "Bunnyhop : %T", "AdminMenu_3agolovok", client);
		SetMenuTitle(menu, buffer);
		Format(buffer, sizeof(buffer), "%T", "TauMep", client);
		AddMenuItem(menu, "", buffer);
		Format(buffer, sizeof(buffer), "%T", "KoMMAHDbI", client);
		AddMenuItem(menu, "", buffer);
		Format(buffer, sizeof(buffer), "%T", "JIuMuTbI", client);
		AddMenuItem(menu, "", buffer);
		Format(buffer, sizeof(buffer), "%T", "DB", client);
		AddMenuItem(menu, "", buffer);
		Format(buffer, sizeof(buffer), "%T", "ReloadMod", client);
		AddMenuItem(menu, "", buffer);

		SetMenuExitButton(menu, true);
		DisplayMenu(menu, client, MENU_TIME_FOREVER);
	}
	else
	PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "NotAuthorized");
}

public AdminMenuHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		switch(param2)
		{
			case 0:
			{
				TimerSet(param1, 1);
			}
			case 1:
			{
				CvarsSet(param1);
			}
			case 2:
			{
				LimitSet(param1);
			}
			case 3:
			{
				DataBaseSet(param1, 1);
			}
			case 4:
			{
				ServerCommand("sm plugins reload BunnyhopMod");
				PrintToChat(param1, "\x01[\x03Bunnyhop\x01] %t", "ModReloaded");
			}
		}
	}

	else if(action == MenuAction_End)
	CloseHandle(menu);
}

public Action:TimerSet(client, args)
{
	decl String:buffer[1024];
	new Handle:menu = CreateMenu(TimerSetHandler);
	Format(buffer, sizeof(buffer), "Bunnyhop : %T", "Timer_3agolovok", client);
	SetMenuTitle(menu, buffer);

	if(g_NullCoords == false)
	{
		Format(buffer, sizeof(buffer), "%T", "Timer_Ha4aJI0", client);
		AddMenuItem(menu, "", buffer, ITEMDRAW_DISABLED);
	}
	else if(g_NullCoords == true)
	{
		Format(buffer, sizeof(buffer), "%T", "Timer_Ha4aJI0", client);
		AddMenuItem(menu, "", buffer, ITEMDRAW_DEFAULT);
	}

	if(g_NullCoords == false)
	{
		Format(buffer, sizeof(buffer), "%T", "Timer_K0Hec", client);
		AddMenuItem(menu, "", buffer, ITEMDRAW_DISABLED);
    }
	else if(g_NullCoords == true)
    {
		Format(buffer, sizeof(buffer), "%T", "Timer_K0Hec", client);
		AddMenuItem(menu, "", buffer, ITEMDRAW_DEFAULT);
	}
	if(g_NullCoords == false)
	{
		Format(buffer, sizeof(buffer), "%T", "Timer_Clear", client, map);
		AddMenuItem(menu, "", buffer, ITEMDRAW_DEFAULT);
    }
	else if(g_NullCoords == true)
    {
		Format(buffer, sizeof(buffer), "%T", "Timer_Clear", client, map);
		AddMenuItem(menu, "", buffer, ITEMDRAW_DISABLED);
	}


	if (!NoClipOnOff)
		Format(buffer, sizeof(buffer), "%T", "Timer_NoClip_ON", client);
	else
		Format(buffer, sizeof(buffer), "%T", "Timer_NoClip_OFF", client);
	AddMenuItem(menu, "", buffer);

	if(g_NullCoords == true)
	{
		if (GetConVarInt(cvarTimer) == 0)
		Format(buffer, sizeof(buffer), "%T", "Timer_BbIKJI", client);
		else
		Format(buffer, sizeof(buffer), "%T", "Timer_BKJI", client);
		AddMenuItem(menu, "", buffer, ITEMDRAW_DISABLED);
	}
	else if(g_NullCoords == false)
	{
		if (GetConVarInt(cvarTimer) == 0)
		Format(buffer, sizeof(buffer), "%T", "Timer_BbIKJI", client);
		else
		Format(buffer, sizeof(buffer), "%T", "Timer_BKJI", client);
		AddMenuItem(menu, "", buffer, ITEMDRAW_DEFAULT);
	}

	SetMenuExitBackButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public TimerSetHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		switch(param2)
		{
			case 0:
			{
				SetTimerCords(param1,0);
				TimerSet(param1, 1);
			}
			case 1:
			{
				SetTimerCords(param1,1);
			}
			case 2:
			{
				ClearInMapTimerCords(param1);
				TimerSet(param1, 1);
			}
			case 3:
			{
				FuncNoClip(param1);
				TimerSet(param1, 0);
			}
			case 4:
			{
				AdminDisableEnableTimer(param1, 0);
				TimerSet(param1, 1);
			}
		}
	}
	if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack)
		{
			CpAdmin(param1, 0);
		}
	}

	else if(action == MenuAction_End)
	CloseHandle(menu);
}

public Action:CvarsSet(client)
{
	decl String:buffer[2048];
	new Handle:menu = CreateMenu(CvarsSetHandler);
	
	Format(buffer, sizeof(buffer), "Bunnyhop : %T", "KoMMAHDbI_3agolovok", client);
	SetMenuTitle(menu, buffer);
	
	if (GetConVarInt(cvarAir) != 100)
	Format(buffer, sizeof(buffer), "%T", "AirAccel_BbIKJI", client);
	else if (GetConVarInt(cvarAir) != 10)
	Format(buffer, sizeof(buffer), "%T", "AirAccel_BKJI", client);
	AddMenuItem(menu, "", buffer);
	
	if (GetConVarInt(cvarNoblock) == 0)
	{
		Format(buffer, sizeof(buffer), "%T", "BlockNoblock_BbIKJI", client);
		SetEntData(client, FindSendPropOffs("CBaseEntity", "m_CollisionGroup"), 2, 4, true);
	}

	else

	Format(buffer, sizeof(buffer), "%T", "BlockNoblock_BKJI", client);
	AddMenuItem(menu, "", buffer);
	
	if (GetConVarInt(cvarTimerHudHint) == 0)
	Format(buffer, sizeof(buffer), "%T", "NowTimerHintText", client);
	
	else
	
	Format(buffer, sizeof(buffer), "%T", "NowTimerHudHint", client);
	AddMenuItem(menu, "", buffer);
	
	if (GetConVarInt(cvarGravity) == 0)
	{
		Format(buffer, sizeof(buffer), "%T", "Gravity_BbIKJI", client);
		SetEntityGravity(client, 1.0);
	}
	
	else
	
	Format(buffer, sizeof(buffer), "%T", "Gravity_BKJI", client);
	AddMenuItem(menu, "", buffer);
	
	if (GetConVarInt(cvarNoFlash) == 0)
	Format(buffer, sizeof(buffer), "%T", "Flash_BbIKJI", client);
	
	else
	
	Format(buffer, sizeof(buffer), "%T", "Flash_BKJI", client);
	AddMenuItem(menu, "", buffer);
	
	if (GetConVarInt(cvarHealClient) == 0)
	Format(buffer, sizeof(buffer), "%T", "HP_BbIKJI", client);
	
	else
	
	Format(buffer, sizeof(buffer), "%T", "HP_BKJI", client);
	AddMenuItem(menu, "", buffer);

	SetMenuExitBackButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public CvarsSetHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		switch(param2)
		{
			case 0:
			{
				if(GetConVarInt(cvarAir) != 100)
				{
					SetConVarInt(cvarAir, 100, true, true);
					PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "AirAccel_100");
				}
				
				else if(GetConVarInt(cvarAir) != 10)
				{
					SetConVarInt(cvarAir, 10, true, true);
					PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "AirAccel_10");
				}
			}
			case 1:
			{
				SetConVarBool(cvarNoblock, FlipBool(GetConVarBool(cvarNoblock)), true, true);
				if(GetConVarInt(cvarNoblock) == 1)
				{
					PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "Nb0n");
				}

				if(GetConVarInt(cvarNoblock) == 0)
				{
					PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "Nb0ff");
					
					for(new i = 0; i <= MAXPLAYERS; i++)
					{
						if(blocking[i] == true)
						{
							SetEntData(i, FindSendPropOffs("CBaseEntity", "m_CollisionGroup"), 2, 4, true);
							blocking[i] = false;
						}
					}
				}
			}
			case 2:
			{
				SetConVarBool(cvarTimerHudHint, FlipBool(GetConVarBool(cvarTimerHudHint)), true, true);
				if(GetConVarInt(cvarTimerHudHint) == 1)
				{
					PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "NowHudHintOn");
				}
				
				if(GetConVarInt(cvarTimerHudHint) == 0)
				{
					PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "NowHintTextOn");
				}
			}
			case 3:
			{
				SetConVarBool(cvarGravity, FlipBool(GetConVarBool(cvarGravity)), true, true);
				
				if(GetConVarInt(cvarGravity) == 1)
				{
					PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "Gravity0n");
				}
				
				if(GetConVarInt(cvarGravity) == 0)
				{
					PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "Gravity0ff");
					
					for(new i = 0; i <= MAXPLAYERS; i++)
					{
						if(g_ClientInGravity[i] == true)
						{
							SetEntityGravity(i, 1.0);
							g_ClientInGravity[i] = false;
						}
					}
				}
			}
			case 4:
			{
				SetConVarBool(cvarNoFlash, FlipBool(GetConVarBool(cvarNoFlash)), true, true);

			}
			case 5:
			{
				SetConVarBool(cvarHealClient, FlipBool(GetConVarBool(cvarHealClient)), true, true);
				
				if(GetConVarInt(cvarHealClient) == 1)
				{
					PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "Hp0n");
					EmitSoundToAll("buttons/button17.wav", SND_CHANGEVOL, 10);
				}
			
				if(GetConVarInt(cvarHealClient) == 0)
				{
					PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "Hp0ff");
					EmitSoundToAll("buttons/button17.wav", SND_CHANGEVOL, 10);
				}
			}
		}
		CvarsSet(param1);
	}
	if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack)
		{
			CpAdmin(param1, 0);
		}
	}

	else if(action == MenuAction_End)
	CloseHandle(menu);
}

public Action:LimitSet(client)
{
	decl String:buffer[1024];
	new Handle:menu = CreateMenu(LimitSetHandler);
	Format(buffer, sizeof(buffer), "Bunnyhop : %T", "JIuMuT_3agolovok", client);
	SetMenuTitle(menu, buffer);
    
	Format(buffer, sizeof(buffer), "%T %i", "JIuMuT_CKAyT", client, GetConVarInt(cvarScoutLimit));
	AddMenuItem(menu, "", buffer);

	Format(buffer, sizeof(buffer), "%T %i", "JIuMuT_4p", client, GetConVarInt(cvarCpLimit));
	AddMenuItem(menu, "", buffer);
    
	SetMenuExitBackButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public LimitSetHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		switch(param2)
		{
			case 0:
			{
				if(GetConVarInt(cvarScoutLimit) < 11)
				{
					SetConVarInt(cvarScoutLimit, GetConVarInt(cvarScoutLimit) + 1, true, true);
				}
				
				if(GetConVarInt(cvarScoutLimit) == 11)
				{
					SetConVarInt(cvarScoutLimit, 0);
					PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "NowScoutsDisabled");
					EmitSoundToAll("buttons/button17.wav", SND_CHANGEVOL, 10);
				}
			}
			case 1:
			{
				if(GetConVarInt(cvarCpLimit) < 101)
				{
					SetConVarInt(cvarCpLimit, GetConVarInt(cvarCpLimit) + 1, true, true);
				}
				if(GetConVarInt(cvarCpLimit) == 101){
					SetConVarInt(cvarCpLimit, 5);
				}
			}
		}
		LimitSet(param1);
	}
	if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack)
		{
			CpAdmin(param1, 0);
		}
	}

	else if(action == MenuAction_End)
	CloseHandle(menu);
}

public Action:DataBaseSet(client, args)
{
	decl String:buffer[1024];
	new Handle:menu = CreateMenu(DataBaseSetHandler);
	Format(buffer, sizeof(buffer), "Bunnyhop : %T", "DB_3agolovok", client);
	SetMenuTitle(menu, buffer);
		
	Format(buffer, sizeof(buffer), "%T", "DB_CTEPETb_BCE_4p", client);
	AddMenuItem(menu, "", buffer);
		
	Format(buffer, sizeof(buffer), "%T", "DB_04ucTKa", client);
	AddMenuItem(menu, "", buffer);
	
	if(g_NullCoords == true)
	{
		Format(buffer, sizeof(buffer), "%T", "DB_04ucTKa_Timer", client);
		AddMenuItem(menu, "", buffer, ITEMDRAW_DISABLED);
	}
	else if(g_NullCoords == false)
	{
		Format(buffer, sizeof(buffer), "%T", "DB_04ucTKa_Timer", client);
		AddMenuItem(menu, "", buffer, ITEMDRAW_DEFAULT);
	}

	SetMenuExitBackButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public DataBaseSetHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		switch(param2)
		{
			case 0:
			{
				Admin_ResetCp(param1, 1);
			}
			case 1:
			{
				Admin_ResetStats(param1, 1);
			}
			case 2:
			{
				Admin_ResetTimer(param1, 1);
			}
		}
	}
	if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack)
		{
			CpAdmin(param1, 0);
		}
	}

	else if(action == MenuAction_End)
	CloseHandle(menu);
}

public SetTimerCords(client, pos)
{
	decl String:query[255];
	new Float:pcords[3];
	new String:cords[255];
	GetClientAbsOrigin(client,pcords);
	Format(cords, sizeof(cords), "%f:%f:%f",pcords[0],pcords[1],pcords[2]);

	if(pos == 0)
	{
		Format(query, sizeof(query), "UPDATE timer SET begincords = '%s' WHERE map = '%s'", cords, map);
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "StartSet");
		EmitSoundToClient(client,"buttons/button17.wav");
		X_Set_Blue(client);
		TE_SetupBeamRingPoint(pcords,15.0,250.0,Plasmabeam,0,0,100,3.0,30.0,0.0,{0,240,0,255},2,0);
		TE_SendToAll();
		SQL_TQuery(db, SQL_CheckCallback, query);
	}
	
	else
	
	{
		Format(query, sizeof(query), "UPDATE timer SET endcords = '%s' WHERE map = '%s'", cords, map);
		PrintToChat(client, "\x01[\x03Bunnyhop\x01] %t", "EndSet");
		EmitSoundToClient(client,"buttons/button17.wav");
		X_Set_Red(client);
		TE_SetupBeamRingPoint(pcords,15.0,250.0,Plasmabeam,0,0,100,3.0,30.0,0.0,{255,70,0,255},2,0);
		TE_SendToAll();
		SQL_TQuery(db, SQL_CheckCallback, query);
		g_NullCoords = false;
		ServerCommand("sm plugins reload BunnyhopMod");
	}
}

public ClearInMapTimerCords(client)
{
	decl String:query[255];
	Format(query, sizeof(query), "UPDATE timer SET begincords = '0.000000:0.000000:0.000000', endcords = '0.000000:0.000000:0.000000' WHERE map = '%s'", map);
	PrintToChat(client, "\x01[\x03Bunnyhop\x01] \x03Координаты на карте \x01%s \x03очищены", map);
	EmitSoundToClient(client,"buttons/button17.wav");
	g_NullCoords = true;
	CreateTimer(1.0, T_X_SetEraser);
	CreateTimer(1.0, T_Set_OX_InMap);
	SQL_TQuery(db, SQL_CheckCallback, query);
	ServerCommand("sm plugins reload BunnyhopMod");
}

public Action:Admin_PurgeCp(client, args)
{
	if(db == INVALID_HANDLE)
	{
		LogError("[Bunnyhop] Error: Invalid database handle");
		return Plugin_Continue;
	}
	
	decl String:query[255];
	decl String:szdays[64];
	GetCmdArg(1, szdays, 64);
	new days = StringToInt(szdays);
	Format(query, sizeof(query), "DELETE FROM checkpoints WHERE last_connect < datetime('now', '-%i days')", days);
	SQL_LockDatabase(db);
	SQL_FastQuery(db, query);
	SQL_UnlockDatabase(db);

	EmitSoundToAll("buttons/button17.wav", SND_CHANGEVOL, 10);
	ServerCommand("sm plugins reload BunnyhopMod");
	PrintToServer("[Bunnyhop] checkpoints players who last connected %i days ago purged...", days);
	ServerCommand("sm plugins reload BunnyhopMod");
	return Plugin_Handled;
}

public Action:Admin_ResetCp(client, args)
{
	if(db == INVALID_HANDLE)
	{
		LogError("[Bunnyhop] Error: Invalid database handle");
		return Plugin_Continue;
	}
	
	SQL_LockDatabase(db);
	SQL_FastQuery(db, "DROP TABLE IF EXISTS checkpoints; VACUUM;");
	SQL_FastQuery(db, sql_CreateCp);
	PrintToServer("[Bunnyhop] table (checkpoints) successfully deleting and create...");
	SQL_UnlockDatabase(db);

	PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "Reset_4p_clients");
	EmitSoundToAll("buttons/button17.wav", SND_CHANGEVOL, 10);
	ServerCommand("sm plugins reload BunnyhopMod");
	return Plugin_Handled;
}

public Action:Admin_ResetTimer(client, args)
{
	if(db == INVALID_HANDLE)
	{
		LogError("[Bunnyhop] Error: Invalid database handle");
		return Plugin_Continue;
	}

	SQL_LockDatabase(db);
	SQL_FastQuery(db, "DROP TABLE IF EXISTS timer; VACUUM;");
	SQL_FastQuery(db, sql_CreateTimer);
	PrintToServer("[Bunnyhop] table (timer) successfully deleting and create...");
	SQL_UnlockDatabase(db);

	CreateTimer(1.0, T_X_SetEraser);
	CreateTimer(1.0, T_Erase_OX_InMap);
	PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "Reset_timer_coords");
	EmitSoundToAll("buttons/button17.wav", SND_CHANGEVOL, 10);
	ServerCommand("sm plugins reload BunnyhopMod");
	
	if(UserTimerActive[client] == false)
	{
		UserTimerActive[client] = true;
	}

	return Plugin_Handled;
}

public Action:Admin_ResetStats(client, args)
{
	if(db == INVALID_HANDLE)
	{
		LogError("[Bunnyhop] Error: Invalid database handle");
		return Plugin_Continue;
	}

	SQL_LockDatabase(db);
	SQL_FastQuery(db, "DROP TABLE IF EXISTS usersstats; VACUUM;");
	SQL_FastQuery(db, sql_CreateStats);
	PrintToServer("[Bunnyhop] table (usersstats) successfully deleting and create...");
	SQL_UnlockDatabase(db);

	PrintToChatAll("\x01[\x03Bunnyhop\x01] %t", "StatsCleared");
	EmitSoundToAll("buttons/button17.wav", SND_CHANGEVOL, 10);
	ServerCommand("sm plugins reload BunnyhopMod");
	
	if(UserTimerActive[client] == false)
	{
		UserTimerActive[client] = true;
	}

	return Plugin_Handled;
}

public Action:T_Set_OX_InMap(Handle:timer, any:client)
{

	XO_ForMaps(client);

}

public Action:T_Erase_OX_InMap(Handle:timer, any:client)
{

	Erase_XO_OnMap(client);

}

/************************************
	do not change this...  =>
*************************************/

public XO_ForMaps(client)
{
	PoSiTiOnSMap_Blue[client][0] = g_MapBeginCoords[0];
	PoSiTiOnSMap_Blue[client][1] = g_MapBeginCoords[1];
	PoSiTiOnSMap_Blue[client][2] = g_MapBeginCoords[2];
	PoSiTiOnSMap_Red[client][0] = g_MapEndCoords[0];
	PoSiTiOnSMap_Red[client][1] = g_MapEndCoords[1];
	PoSiTiOnSMap_Red[client][2] = g_MapEndCoords[2];

	if(XO_ForMaps_hand[client] != INVALID_HANDLE)
	{
		CloseHandle(XO_ForMaps_hand[client]);
		XO_ForMaps_hand[client] = INVALID_HANDLE;
	}

	X_setPos_ForMap[client][0] = true;
	XO_ForMaps_hand[client] = CreateTimer(1.0, T_XO_ForMap, client, TIMER_REPEAT);
}

public Action:T_XO_ForMap(Handle:timer, any:client)
{
	L_X_ForMap(client);
	L_O_ForMap(client);
}

public Erase_XO_OnMap(client)
{
	if(XO_ForMaps_hand[client] != INVALID_HANDLE)
	{
		CloseHandle(XO_ForMaps_hand[client]);
		XO_ForMaps_hand[client] = INVALID_HANDLE;
	}
}

public Action:L_O_ForMap(client)
{

	TE_SetupBeamRingPoint(g_MapBeginCoords,199.0,200.0,Plasmabeam,0,10,500,0.99,40.0,0.0,{0,20,240,255},2,0);
	TE_SendToAll();
	TE_SetupBeamRingPoint(g_MapEndCoords,199.0,200.0,Plasmabeam,0,10,500,0.99,40.0,0.0,{240,20,0,255},2,0);
	TE_SendToAll();
}

L_X_ForMap(client)
{
	new Float:L_X_1End[3];
	new Float:L_X_2End[3];
	new Float:L_X_3End[3];
	new Float:L_X_4End[3];

	new Float:L_XX_1End[3];
	new Float:L_XX_2End[3];
	new Float:L_XX_3End[3];
	new Float:L_XX_4End[3];
	
	L_X_1End[0] = (PoSiTiOnSMap_Blue[client][0] - 150);
	L_X_1End[1] = (PoSiTiOnSMap_Blue[client][1]);
	L_X_1End[2] = (PoSiTiOnSMap_Blue[client][2]);

	L_X_2End[0] = (PoSiTiOnSMap_Blue[client][0] + 150);
	L_X_2End[1] = (PoSiTiOnSMap_Blue[client][1]);
	L_X_2End[2] = (PoSiTiOnSMap_Blue[client][2]);

	L_X_3End[0] = (PoSiTiOnSMap_Blue[client][0]);
	L_X_3End[1] = (PoSiTiOnSMap_Blue[client][1] - 150);
	L_X_3End[2] = (PoSiTiOnSMap_Blue[client][2]);

	L_X_4End[0] = (PoSiTiOnSMap_Blue[client][0]);
	L_X_4End[1] = (PoSiTiOnSMap_Blue[client][1] + 150);
	L_X_4End[2] = (PoSiTiOnSMap_Blue[client][2]);
	
	L_XX_1End[0] = (PoSiTiOnSMap_Red[client][0] + 150);
	L_XX_1End[1] = (PoSiTiOnSMap_Red[client][1]);
	L_XX_1End[2] = (PoSiTiOnSMap_Red[client][2]);

	L_XX_2End[0] = (PoSiTiOnSMap_Red[client][0] - 150);
	L_XX_2End[1] = (PoSiTiOnSMap_Red[client][1]);
	L_XX_2End[2] = (PoSiTiOnSMap_Red[client][2]);

	L_XX_3End[0] = (PoSiTiOnSMap_Red[client][0]);
	L_XX_3End[1] = (PoSiTiOnSMap_Red[client][1] + 150);
	L_XX_3End[2] = (PoSiTiOnSMap_Red[client][2]);

	L_XX_4End[0] = (PoSiTiOnSMap_Red[client][0]);
	L_XX_4End[1] = (PoSiTiOnSMap_Red[client][1] - 150);
	L_XX_4End[2] = (PoSiTiOnSMap_Red[client][2]);
	
	L_X_Settings(PoSiTiOnSMap_Blue[client], L_X_1End, 0.99, 15.0, 0, 0, 240);
	L_X_Settings(PoSiTiOnSMap_Blue[client], L_X_2End, 0.99, 15.0, 0, 0, 240);
	L_X_Settings(PoSiTiOnSMap_Blue[client], L_X_3End, 0.99, 15.0, 0, 0, 240);
	L_X_Settings(PoSiTiOnSMap_Blue[client], L_X_4End, 0.99, 15.0, 0, 0, 240);
	
	L_X_Settings(PoSiTiOnSMap_Red[client], L_XX_1End, 0.99, 15.0, 255, 70, 0);
	L_X_Settings(PoSiTiOnSMap_Red[client], L_XX_2End, 0.99, 15.0, 255, 70, 0);
	L_X_Settings(PoSiTiOnSMap_Red[client], L_XX_3End, 0.99, 15.0, 255, 70, 0);
	L_X_Settings(PoSiTiOnSMap_Red[client], L_XX_4End, 0.99, 15.0, 255, 70, 0);
}

public X_Set_Red(client)
{
	new Float:oriG[3];
	GetClientAbsOrigin(client, oriG);
	
	PoSiTiOnS_Red[client][0] = oriG[0];
	PoSiTiOnS_Red[client][1] = oriG[1];
	PoSiTiOnS_Red[client][2] = oriG[2];
	
	if(handler_X_Red[client] != INVALID_HANDLE)
	{
		CloseHandle(handler_X_Red[client]);
		handler_X_Red[client] = INVALID_HANDLE;
	}

	X_setPos[client][0] = true;
	handler_X_Red[client] = CreateTimer(1.0, T_X_Red, client, TIMER_REPEAT);
	L_X_ForSeT_Red(client);
}

public X_Set_Blue(client)
{
	new Float:oriG[3];
	GetClientAbsOrigin(client, oriG);
	
	PoSiTiOnS_Blue[client][0] = oriG[0];
	PoSiTiOnS_Blue[client][1] = oriG[1];
	PoSiTiOnS_Blue[client][2] = oriG[2];

	if(handler_X_Blue[client] != INVALID_HANDLE)
	{
		CloseHandle(handler_X_Blue[client]);
		handler_X_Blue[client] = INVALID_HANDLE;
	}

	X_setPos[client][0] = true;
	handler_X_Blue[client] = CreateTimer(1.0, T_X_Blue, client, TIMER_REPEAT);
	L_X_ForSeT_Blue(client);
}

public Action:T_X_Red(Handle:timer,any:client)
{
	L_X_ForSeT_Red(client);
}

public Action:T_X_Blue(Handle:timer,any:client)
{
	L_X_ForSeT_Blue(client);
}

public Action:T_X_SetEraser(Handle:timer, any:client)
{
	Erase_X_Set_Red(client);
	Erase_X_Set_Blue(client);
}

public Erase_X_Set_Red(client)
{
	if(handler_X_Red[client] != INVALID_HANDLE)
	{
		CloseHandle(handler_X_Red[client]);
		handler_X_Red[client] = INVALID_HANDLE;
	}
}

public Erase_X_Set_Blue(client)
{
	if(handler_X_Blue[client] != INVALID_HANDLE)
	{
		CloseHandle(handler_X_Blue[client]);
		handler_X_Blue[client] = INVALID_HANDLE;
	}
}

L_X_ForSeT_Blue(client)
{
	new Float:L_X_1End[3];
	new Float:L_X_2End[3];
	new Float:L_X_3End[3];
	new Float:L_X_4End[3];
	
	L_X_1End[0] = (PoSiTiOnS_Blue[client][0] - 150);
	L_X_1End[1] = (PoSiTiOnS_Blue[client][1]);
	L_X_1End[2] = (PoSiTiOnS_Blue[client][2]);

	L_X_2End[0] = (PoSiTiOnS_Blue[client][0] + 150);
	L_X_2End[1] = (PoSiTiOnS_Blue[client][1]);
	L_X_2End[2] = (PoSiTiOnS_Blue[client][2]);

	L_X_3End[0] = (PoSiTiOnS_Blue[client][0]);
	L_X_3End[1] = (PoSiTiOnS_Blue[client][1] - 150);
	L_X_3End[2] = (PoSiTiOnS_Blue[client][2]);

	L_X_4End[0] = (PoSiTiOnS_Blue[client][0]);
	L_X_4End[1] = (PoSiTiOnS_Blue[client][1] + 150);
	L_X_4End[2] = (PoSiTiOnS_Blue[client][2]);
	
	L_X_Settings(PoSiTiOnS_Blue[client], L_X_1End, 0.97, 10.0, 0, 0, 240);
	L_X_Settings(PoSiTiOnS_Blue[client], L_X_2End, 0.97, 10.0, 0, 0, 240);
	L_X_Settings(PoSiTiOnS_Blue[client], L_X_3End, 0.97, 10.0, 0, 0, 240);
	L_X_Settings(PoSiTiOnS_Blue[client], L_X_4End, 0.97, 10.0, 0, 0, 240);
}

L_X_ForSeT_Red(client)
{
	new Float:L_X_1End[3];
	new Float:L_X_2End[3];
	new Float:L_X_3End[3];
	new Float:L_X_4End[3];

	L_X_1End[0] = (PoSiTiOnS_Red[client][0] + 150);
	L_X_1End[1] = (PoSiTiOnS_Red[client][1]);
	L_X_1End[2] = (PoSiTiOnS_Red[client][2]);

	L_X_2End[0] = (PoSiTiOnS_Red[client][0] - 150);
	L_X_2End[1] = (PoSiTiOnS_Red[client][1]);
	L_X_2End[2] = (PoSiTiOnS_Red[client][2]);

	L_X_3End[0] = (PoSiTiOnS_Red[client][0]);
	L_X_3End[1] = (PoSiTiOnS_Red[client][1] + 150);
	L_X_3End[2] = (PoSiTiOnS_Red[client][2]);

	L_X_4End[0] = (PoSiTiOnS_Red[client][0]);
	L_X_4End[1] = (PoSiTiOnS_Red[client][1] - 150);
	L_X_4End[2] = (PoSiTiOnS_Red[client][2]);
	
	L_X_Settings(PoSiTiOnS_Red[client], L_X_1End, 0.99, 10.0, 255, 20, 0);
	L_X_Settings(PoSiTiOnS_Red[client], L_X_2End, 0.99, 10.0, 255, 20, 0);
	L_X_Settings(PoSiTiOnS_Red[client], L_X_3End, 0.99, 10.0, 255, 20, 0);
	L_X_Settings(PoSiTiOnS_Red[client], L_X_4End, 0.99, 10.0, 255, 20, 0);
}

L_X_Settings(Float:vecStart[3],Float:vecEnd[3],Float:life,Float:width,r,g,b)
{
	TE_Start("BeamPoints");
	TE_WriteNum("m_nModelIndex",Plasmabeam);
	TE_WriteNum("m_nHaloIndex",0);
	TE_WriteNum("m_nStartFrame",0);
	TE_WriteNum("m_nFrameRate",0);
	TE_WriteFloat("m_fLife",life);
	TE_WriteFloat("m_fWidth",width);
	TE_WriteFloat("m_fEndWidth",width);
	TE_WriteNum("m_nFadeLength",0);
	TE_WriteFloat("m_fAmplitude",0.0);
	TE_WriteNum("m_nSpeed", 2);
	TE_WriteNum("r",r);
	TE_WriteNum("g",g);
	TE_WriteNum("b",b);
	TE_WriteNum("a",255);
	TE_WriteNum("m_nFlags", 0);
	TE_WriteVector("m_vecStartPoint",vecStart);
	TE_WriteVector("m_vecEndPoint",vecEnd);
	TE_SendToAll();
}

public Action:CfgWrite()
{
	new String:PathBuilded[256];
	Format(PathBuilded, sizeof(PathBuilded), "%s%s", GetPath, GetFileName);

	new Handle:createCFG = OpenFile(PathBuilded, "wt");
	if (createCFG == INVALID_HANDLE)
	{
		PrintToServer("[Bunnyhop] cfg file not created : %s", PathBuilded);
	}
	else

	WriteFileLine(createCFG, "//****************************************\n//\n//Bunnyhop mod\n//by (t*Q)\n//\n//Configurations (Настройки)\n// \n//****************************************\n\n\n");

	new onoff = GetConVarInt(cvarEnable);
	WriteFileLine(createCFG, "//Включить/отключить мод\n//если (0) то будут недоступны чекпоинты\n//Enable/Disable plugin\n//1 - включено\n//0 - отключено\n//----------\nbh_enabled %i\n\n", onoff);

	new hhint = GetConVarInt(cvarTimerHudHint);
	WriteFileLine(createCFG, "//Таймер в виде HudHint или HintText\n//Timer HudHint or HintText\n//1 - HudHint\n//0 - HintText\n//----------\nbh_timerhudhint %i\n\n", hhint);

	new noflash = GetConVarInt(cvarNoFlash);
	WriteFileLine(createCFG, "//Ослепление от флеш гранат\n//Enable/Disable flashbang blend\n//1 - включено\n//0 - отключено\n//----------\nbh_noflash %i\n\n", noflash);
	
	new block = GetConVarInt(cvarNoblock);
	WriteFileLine(createCFG, "//Разрешать игрокам блочиться? командой !b\n//Enable/Disable player blocking\n//1 - включено\n//0 - отключено\n//----------\nbh_noblock %i\n\n", block);
	
	new gravity = GetConVarInt(cvarGravity);
	WriteFileLine(createCFG, "//Разрешать игрокам пользоваться гравитацией? команды !lg/!ng\n//Enable/Disable player gravity commands\n//1 - включено\n//0 - отключено\n//----------\nbh_gravity %i\n\n", gravity);
	
	new hp = GetConVarInt(cvarHealClient);
	WriteFileLine(createCFG, "//Восстанавливать игрокам ХП\n//Enable/Disable healing of damage\n//1 - включено\n//0 - отключено\n//----------\nbh_healclient %i\n\n", hp);
	
	new cpdb = GetConVarInt(cvarRestore);
	WriteFileLine(createCFG, "//Восстанавливать чекпоинты игрокам из Базы данных?\n//Enable/Disable automatic saving of checkpoints to database\n//1 - включено\n//0 - отключено\n//----------\nbh_restore %i\n\n", cpdb);
	
	new timer = GetConVarInt(cvarTimer);
	WriteFileLine(createCFG, "//Включить/Отключить таймер по дефолту т.е совсем\n//Enable/Disable map Timer!\n//----------\nbh_timer_enable %i\n\n", timer);
	
	new scs = GetConVarInt(cvarScoutLimit);
	WriteFileLine(createCFG, "//Ограничения скаутов\n//Sets the scout limit for each player\n//10 - максимум\n//0 - отключено\n//----------\nbh_scoutlimit %i\n\n", scs);
	
	new cplimits = GetConVarInt(cvarCpLimit);
	WriteFileLine(createCFG, "//Ограничения чекпоинтов\n//Sets the cp limit for each player\n//5 - минимум\n//50 - максимум\n//----------\nbh_cplimit %i\n\n", cplimits);

	CloseHandle(createCFG);
}

public Action:CfgRead()
{
	new String:PathBuilded[256];
	Format(PathBuilded, sizeof(PathBuilded), "%s%s", GetPath, GetFileName);

	new Handle:readCFG = OpenFile(PathBuilded, "rt");
	if (readCFG == INVALID_HANDLE)
	{
		PrintToServer("[Bunnyhop] cfg file not found : %s", PathBuilded);
	}
	else

	while(!IsEndOfFile(readCFG))
	{
		decl String:lines[4096];
		ReadFileLine(readCFG, lines, sizeof(lines));
		if(lines[0] == ' ' || lines[0] == '/' || lines[0] == '\0')
		continue;
		Trimming_andExec_line(lines);
	}
	
	CloseHandle(readCFG);
}

Trimming_andExec_line(String:line[])
{
	new String:CompletedTrimming[4096];

	TrimString(line);
	if (strlen(line) == 0 || (line[0] == '/' && line[1] == '/'))
	{
		return;
	}
	new bool:qt = false;
	for (new i = 0; i < strlen(line); i++)
	{
		if (line[i] == '"')
		{
			qt=!qt;
		}
		if (i==0 && line[i] == ';')
		{
			line[i]=' ';
		}
		if (line[i] == '/' && line[i+1] == '/')
		{
			TrimString(CompletedTrimming);
			break;
		}
		if (line[i] == ';' && !qt)
		{
			TrimString(CompletedTrimming);
			if (strlen(CompletedTrimming) == 0)
			{
				return;
			}
			ReplaceString(line, strlen(line), CompletedTrimming, "");
			Trimming_andExec_line(line);
			return;
		}
		CompletedTrimming[i]=line[i];
	}
	
	TrimString(CompletedTrimming);
	if (strlen(CompletedTrimming) == 0)
	{
		return;
	}
	//used this for debug...
	//PrintToServer("%s", CompletedTrimming);
	ServerCommand("%s",CompletedTrimming);
}

/****************************************************************/

public Action:HelpPanel(client)
{
	EmitSoundToClient(client,"buttons/button17.wav");
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelItem(panel, "!timerstop и !timerenable");
	DrawPanelItem(panel, "!hud");
	DrawPanelItem(panel, "!speed");
	DrawPanelItem(panel, "!wr и !top");
	DrawPanelItem(panel, "!me и !statsme");
	DrawPanelItem(panel, "!block и !b");
	DrawPanelItem(panel, "!scout и !st");
	DrawPanelItem(panel, " ", ITEMDRAW_SPACER);
	DrawPanelItem(panel, "Далее");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanelHandler, 120);
	CloseHandle(panel);
}

public HelpPanelHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanelTimerStopEnable(param1);
		}
		if(param2 == 2)
		{
			HelpPanelHudOrHint(param1);
		}
		if(param2 == 3)
		{
			HelpPanelSpeed(param1);
		}
		if(param2 == 4)
		{
			HelpPanelWrOrTop(param1);
		}
		if(param2 == 5)
		{
			HelpPanelMeOrStatsMe(param1);
		}
		if(param2 == 6)
		{
			HelpPanelBlockOrB(param1);
		}
		if(param2 == 7)
		{
			HelpPanelScoutOrSt(param1);
		}
		if(param2 == 9)
		{
			HelpPanel2(param1);
		}
	}
}

public HelpPanelTimerStopEnable(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!timerstop и !timerenable");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "Включить отключить свой таймер");
	DrawPanelText(panel, "если проходить карту на время");
	DrawPanelText(panel, "чекпоинты будут недоступны!");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanelTimerStopEnableHandler, 120);
	CloseHandle(panel);
}

public HelpPanelTimerStopEnableHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public HelpPanelHudOrHint(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!hud");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "переключить показ своего таймера");
	DrawPanelText(panel, "в режим HudHint (справа) или");
	DrawPanelText(panel, "в режим HintText (по середине)");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanelHudOrHintHandler, 120);
	CloseHandle(panel);
}

public HelpPanelHudOrHintHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public HelpPanelSpeed(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!speed");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "включить/отключить показ");
	DrawPanelText(panel, "скорости в вашем таймере");
	DrawPanelText(panel, "показывается в юнитах и в км.ч");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanelSpeedHandler, 120);
	CloseHandle(panel);
}

public HelpPanelSpeedHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public HelpPanelWrOrTop(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!wr или !top");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "показать топ 10 рекордов");
	DrawPanelText(panel, "на текущей карте");
	DrawPanelText(panel, "(рекорды учитываются по времени)");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanelWrOrTopHandler, 120);
	CloseHandle(panel);
}

public HelpPanelWrOrTopHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public HelpPanelMeOrStatsMe(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!me или !statsme");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "показывает вашу статистику и ранг");
	DrawPanelText(panel, "на текущей карте (из базы данных)");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanelMeOrStatsMeHandler, 120);
	CloseHandle(panel);
}

public HelpPanelMeOrStatsMeHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public HelpPanelBlockOrB(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!block или !b");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "блок или разблок");
	DrawPanelText(panel, "(возможность проходить сквозь друг друга)");
	DrawPanelText(panel, "работает только если разрешено админом");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanelBlockOrBHandler, 120);
	CloseHandle(panel);
}

public HelpPanelBlockOrBHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public HelpPanelScoutOrSt(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!scout или !st");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "взять скаут");
	DrawPanelText(panel, "(на скауты есть лимит установленный админом)");
	DrawPanelText(panel, "работает только если разрешено админом");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanelScoutOrStHandler, 120);
	CloseHandle(panel);
}

public HelpPanelScoutOrStHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public Action:HelpPanel2(client)
{
	EmitSoundToClient(client,"buttons/button17.wav");
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelItem(panel, "!lg и !ng");
	DrawPanelItem(panel, "!cp и !menu");
	DrawPanelItem(panel, "!save и !s");
	DrawPanelItem(panel, "!tele и !t");
	DrawPanelItem(panel, "!prev и !p");
	DrawPanelItem(panel, "!next и !n");
	DrawPanelItem(panel, "!clear и !c");
	DrawPanelItem(panel, "!aboutme (об этом моде)");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanel2Handler, 120);
	CloseHandle(panel);
}

public HelpPanel2Handler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel2LgOrNg(param1);
		}
		if(param2 == 2)
		{
			HelpPanel2CpOrMenu(param1);
		}
		if(param2 == 3)
		{
			HelpPanel2SaveOrs(param1);
		}
		if(param2 == 4)
		{
			HelpPanel2TeleOrT(param1);
		}
		if(param2 == 5)
		{
			HelpPanel2PrevOrP(param1);
		}
		if(param2 == 6)
		{
			HelpPanel2NextOrN(param1);
		}
		if(param2 == 7)
		{
			HelpPanel2ClearOrC(param1);
		}
		if(param2 == 8)
		{
			HelpPanel2ABOUT(param1);
		}
		if(param2 == 9)
		{
			HelpPanel(param1);
		}
	}
}

public HelpPanel2LgOrNg(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!lg или !ng");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "гравитация (низкая/нормальная)");
	DrawPanelText(panel, "работает только если разрешено админом");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanel2LgOrNgHandler, 120);
	CloseHandle(panel);
}

public HelpPanel2LgOrNgHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel2(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public HelpPanel2CpOrMenu(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!cp или !menu");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "меню чекпоинтов");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, "работает только если вы не проходите карту");
	DrawPanelText(panel, "на время. чтобы отключить таймер нужно ввести");
	DrawPanelText(panel, "!timerstop тогда чекпоинты станут доступны");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanel2CpOrMenuHandler, 120);
	CloseHandle(panel);
}

public HelpPanel2CpOrMenuHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel2(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public HelpPanel2SaveOrs(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!save или !s");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "сохранить текущую позицию(чекпоинт)");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, "работает только если вы не проходите карту");
	DrawPanelText(panel, "на время. чтобы отключить таймер нужно ввести");
	DrawPanelText(panel, "!timerstop тогда чекпоинты станут доступны");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanel2SaveOrsHandler, 120);
	CloseHandle(panel);
}

public HelpPanel2SaveOrsHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel2(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public HelpPanel2TeleOrT(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!tele или !t");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "телепорт в последнюю сохранённую позицию(чекпоинт)");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, "работает только если вы не проходите карту");
	DrawPanelText(panel, "на время. чтобы отключить таймер нужно ввести");
	DrawPanelText(panel, "!timerstop тогда чекпоинты станут доступны");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanel2TeleOrTHandler, 120);
	CloseHandle(panel);
}

public HelpPanel2TeleOrTHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel2(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public HelpPanel2PrevOrP(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!prev или !p");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "телепорт на предидущую сохранённую позицию(чекпоинт)");
	DrawPanelText(panel, "из всех ваших сохранённых");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, "работает только если вы не проходите карту");
	DrawPanelText(panel, "на время. чтобы отключить таймер нужно ввести");
	DrawPanelText(panel, "!timerstop тогда чекпоинты станут доступны");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanel2PrevOrPHandler, 120);
	CloseHandle(panel);
}

public HelpPanel2PrevOrPHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel2(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public HelpPanel2NextOrN(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!next или !n");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "телепорт на следующую сохранённую позицию(чекпоинт)");
	DrawPanelText(panel, "из всех ваших сохранённых");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, "работает только если вы не проходите карту");
	DrawPanelText(panel, "на время. чтобы отключить таймер нужно ввести");
	DrawPanelText(panel, "!timerstop тогда чекпоинты станут доступны");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanel2NextOrNHandler, 120);
	CloseHandle(panel);
}

public HelpPanel2NextOrNHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel2(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public HelpPanel2ClearOrC(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!clear или !c");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "стереть ваши сохранённые позиции (чекпоинты)");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, "работает только если вы не проходите карту");
	DrawPanelText(panel, "на время. чтобы отключить таймер нужно ввести");
	DrawPanelText(panel, "!timerstop тогда чекпоинты станут доступны");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Назад");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanel2ClearOrCHandler, 120);
	CloseHandle(panel);
}

public HelpPanel2ClearOrCHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			HelpPanel2(param1);
		}
		if(param2 == 2)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public HelpPanel2ABOUT(client)
{
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, "t*Q Bunnyhop mod");
	DrawPanelText(panel, "----------------------------");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "Информация о моде");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "Этот мод полная модификация cPMOD'а by byaaaaah");
	DrawPanelText(panel, "переписан от начала и до конца (версия 5.0)");
	DrawPanelText(panel, "t*Q web:www.hlmod.ru");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, " ");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "Закрыть");

	SendPanelToClient(panel, client, HelpPanel2ABOUTHandler, 120);
	CloseHandle(panel);
}

public HelpPanel2ABOUTHandler(Handle:Panel, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			Panel = INVALID_HANDLE;
		}
	}
}

public OnPluginEnd()
{
	PrintToServer("[Bunnyhop] Successful unloaded...");
}


